/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 30 "core/cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 232 "core/cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CORE_CFG_TAB_H_INCLUDED
# define YY_YY_CORE_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    FORWARD_TCP = 259,
    FORWARD_TLS = 260,
    FORWARD_SCTP = 261,
    FORWARD_UDP = 262,
    EXIT = 263,
    DROP = 264,
    RETURN = 265,
    BREAK = 266,
    LOG_TOK = 267,
    ERROR = 268,
    ROUTE = 269,
    ROUTE_REQUEST = 270,
    ROUTE_FAILURE = 271,
    ROUTE_ONREPLY = 272,
    ROUTE_REPLY = 273,
    ROUTE_BRANCH = 274,
    ROUTE_SEND = 275,
    ROUTE_EVENT = 276,
    EXEC = 277,
    SET_HOST = 278,
    SET_HOSTPORT = 279,
    SET_HOSTPORTTRANS = 280,
    PREFIX = 281,
    STRIP = 282,
    STRIP_TAIL = 283,
    SET_USERPHONE = 284,
    APPEND_BRANCH = 285,
    REMOVE_BRANCH = 286,
    CLEAR_BRANCHES = 287,
    SET_USER = 288,
    SET_USERPASS = 289,
    SET_PORT = 290,
    SET_URI = 291,
    REVERT_URI = 292,
    FORCE_RPORT = 293,
    ADD_LOCAL_RPORT = 294,
    FORCE_TCP_ALIAS = 295,
    UDP_MTU = 296,
    UDP_MTU_TRY_PROTO = 297,
    UDP4_RAW = 298,
    UDP4_RAW_MTU = 299,
    UDP4_RAW_TTL = 300,
    IF = 301,
    ELSE = 302,
    SET_ADV_ADDRESS = 303,
    SET_ADV_PORT = 304,
    FORCE_SEND_SOCKET = 305,
    SET_FWD_NO_CONNECT = 306,
    SET_RPL_NO_CONNECT = 307,
    SET_FWD_CLOSE = 308,
    SET_RPL_CLOSE = 309,
    SWITCH = 310,
    CASE = 311,
    DEFAULT = 312,
    WHILE = 313,
    CFG_SELECT = 314,
    CFG_RESET = 315,
    URIHOST = 316,
    URIPORT = 317,
    MAX_LEN = 318,
    SETFLAG = 319,
    RESETFLAG = 320,
    ISFLAGSET = 321,
    SETAVPFLAG = 322,
    RESETAVPFLAG = 323,
    ISAVPFLAGSET = 324,
    METHOD = 325,
    URI = 326,
    FROM_URI = 327,
    TO_URI = 328,
    SRCIP = 329,
    SRCPORT = 330,
    DSTIP = 331,
    DSTPORT = 332,
    TOIP = 333,
    TOPORT = 334,
    SNDIP = 335,
    SNDPORT = 336,
    SNDPROTO = 337,
    SNDAF = 338,
    PROTO = 339,
    AF = 340,
    MYSELF = 341,
    MSGLEN = 342,
    UDP = 343,
    TCP = 344,
    TLS = 345,
    SCTP = 346,
    WS = 347,
    WSS = 348,
    DEBUG_V = 349,
    FORK = 350,
    FORK_DELAY = 351,
    MODINIT_DELAY = 352,
    LOGSTDERROR = 353,
    LOGFACILITY = 354,
    LOGNAME = 355,
    LOGCOLOR = 356,
    LOGPREFIX = 357,
    LOGPREFIXMODE = 358,
    LOGENGINETYPE = 359,
    LOGENGINEDATA = 360,
    XAVPVIAPARAMS = 361,
    XAVPVIAFIELDS = 362,
    LISTEN = 363,
    ADVERTISE = 364,
    STRNAME = 365,
    ALIAS = 366,
    SR_AUTO_ALIASES = 367,
    DNS = 368,
    REV_DNS = 369,
    DNS_TRY_IPV6 = 370,
    DNS_TRY_NAPTR = 371,
    DNS_SRV_LB = 372,
    DNS_UDP_PREF = 373,
    DNS_TCP_PREF = 374,
    DNS_TLS_PREF = 375,
    DNS_SCTP_PREF = 376,
    DNS_RETR_TIME = 377,
    DNS_SLOW_QUERY_MS = 378,
    DNS_RETR_NO = 379,
    DNS_SERVERS_NO = 380,
    DNS_USE_SEARCH = 381,
    DNS_SEARCH_FMATCH = 382,
    DNS_NAPTR_IGNORE_RFC = 383,
    DNS_CACHE_INIT = 384,
    DNS_USE_CACHE = 385,
    DNS_USE_FAILOVER = 386,
    DNS_CACHE_FLAGS = 387,
    DNS_CACHE_NEG_TTL = 388,
    DNS_CACHE_MIN_TTL = 389,
    DNS_CACHE_MAX_TTL = 390,
    DNS_CACHE_MEM = 391,
    DNS_CACHE_GC_INT = 392,
    DNS_CACHE_DEL_NONEXP = 393,
    DNS_CACHE_REC_PREF = 394,
    AUTO_BIND_IPV6 = 395,
    BIND_IPV6_LINK_LOCAL = 396,
    DST_BLST_INIT = 397,
    USE_DST_BLST = 398,
    DST_BLST_MEM = 399,
    DST_BLST_TTL = 400,
    DST_BLST_GC_INT = 401,
    DST_BLST_UDP_IMASK = 402,
    DST_BLST_TCP_IMASK = 403,
    DST_BLST_TLS_IMASK = 404,
    DST_BLST_SCTP_IMASK = 405,
    IP_FREE_BIND = 406,
    PORT = 407,
    STAT = 408,
    CHILDREN = 409,
    SOCKET_WORKERS = 410,
    ASYNC_WORKERS = 411,
    ASYNC_USLEEP = 412,
    ASYNC_NONBLOCK = 413,
    CHECK_VIA = 414,
    PHONE2TEL = 415,
    MEMLOG = 416,
    MEMDBG = 417,
    MEMSUM = 418,
    MEMSAFETY = 419,
    MEMJOIN = 420,
    MEMSTATUSMODE = 421,
    SIP_PARSER_LOG = 422,
    CORELOG = 423,
    SIP_WARNING = 424,
    SERVER_SIGNATURE = 425,
    SERVER_HEADER = 426,
    USER_AGENT_HEADER = 427,
    REPLY_TO_VIA = 428,
    LOADMODULE = 429,
    LOADPATH = 430,
    MODPARAM = 431,
    CFGENGINE = 432,
    MAXBUFFER = 433,
    SQL_BUFFER_SIZE = 434,
    USER = 435,
    GROUP = 436,
    CHROOT = 437,
    WDIR = 438,
    RUNDIR = 439,
    MHOMED = 440,
    DISABLE_TCP = 441,
    TCP_ACCEPT_ALIASES = 442,
    TCP_ACCEPT_UNIQUE = 443,
    TCP_CONNECTION_MATCH = 444,
    TCP_CHILDREN = 445,
    TCP_CONNECT_TIMEOUT = 446,
    TCP_SEND_TIMEOUT = 447,
    TCP_CON_LIFETIME = 448,
    TCP_POLL_METHOD = 449,
    TCP_MAX_CONNECTIONS = 450,
    TLS_MAX_CONNECTIONS = 451,
    TCP_NO_CONNECT = 452,
    TCP_SOURCE_IPV4 = 453,
    TCP_SOURCE_IPV6 = 454,
    TCP_OPT_FD_CACHE = 455,
    TCP_OPT_BUF_WRITE = 456,
    TCP_OPT_CONN_WQ_MAX = 457,
    TCP_OPT_WQ_MAX = 458,
    TCP_OPT_RD_BUF = 459,
    TCP_OPT_WQ_BLK = 460,
    TCP_OPT_DEFER_ACCEPT = 461,
    TCP_OPT_DELAYED_ACK = 462,
    TCP_OPT_SYNCNT = 463,
    TCP_OPT_LINGER2 = 464,
    TCP_OPT_KEEPALIVE = 465,
    TCP_OPT_KEEPIDLE = 466,
    TCP_OPT_KEEPINTVL = 467,
    TCP_OPT_KEEPCNT = 468,
    TCP_OPT_CRLF_PING = 469,
    TCP_OPT_ACCEPT_NO_CL = 470,
    TCP_OPT_ACCEPT_HEP3 = 471,
    TCP_OPT_ACCEPT_HAPROXY = 472,
    TCP_CLONE_RCVBUF = 473,
    TCP_REUSE_PORT = 474,
    DISABLE_TLS = 475,
    ENABLE_TLS = 476,
    TLSLOG = 477,
    TLS_PORT_NO = 478,
    TLS_METHOD = 479,
    TLS_HANDSHAKE_TIMEOUT = 480,
    TLS_SEND_TIMEOUT = 481,
    SSLv23 = 482,
    SSLv2 = 483,
    SSLv3 = 484,
    TLSv1 = 485,
    TLS_VERIFY = 486,
    TLS_REQUIRE_CERTIFICATE = 487,
    TLS_CERTIFICATE = 488,
    TLS_PRIVATE_KEY = 489,
    TLS_CA_LIST = 490,
    DISABLE_SCTP = 491,
    ENABLE_SCTP = 492,
    SCTP_CHILDREN = 493,
    ADVERTISED_ADDRESS = 494,
    ADVERTISED_PORT = 495,
    DISABLE_CORE = 496,
    OPEN_FD_LIMIT = 497,
    SHM_MEM_SZ = 498,
    SHM_FORCE_ALLOC = 499,
    MLOCK_PAGES = 500,
    REAL_TIME = 501,
    RT_PRIO = 502,
    RT_POLICY = 503,
    RT_TIMER1_PRIO = 504,
    RT_TIMER1_POLICY = 505,
    RT_TIMER2_PRIO = 506,
    RT_TIMER2_POLICY = 507,
    MCAST_LOOPBACK = 508,
    MCAST_TTL = 509,
    MCAST = 510,
    TOS = 511,
    PMTU_DISCOVERY = 512,
    KILL_TIMEOUT = 513,
    MAX_WLOOPS = 514,
    PVBUFSIZE = 515,
    PVBUFSLOTS = 516,
    PVCACHELIMIT = 517,
    PVCACHEACTION = 518,
    HTTP_REPLY_PARSE = 519,
    VERSION_TABLE_CFG = 520,
    VERBOSE_STARTUP = 521,
    ROUTE_LOCKS_SIZE = 522,
    CFG_DESCRIPTION = 523,
    SERVER_ID = 524,
    KEMI = 525,
    ONSEND_ROUTE_CALLBACK = 526,
    REPLY_ROUTE_CALLBACK = 527,
    EVENT_ROUTE_CALLBACK = 528,
    RECEIVED_ROUTE_CALLBACK = 529,
    RECEIVED_ROUTE_MODE = 530,
    MAX_RECURSIVE_LEVEL = 531,
    MAX_BRANCHES_PARAM = 532,
    LATENCY_CFG_LOG = 533,
    LATENCY_LOG = 534,
    LATENCY_LIMIT_DB = 535,
    LATENCY_LIMIT_ACTION = 536,
    LATENCY_LIMIT_CFG = 537,
    MSG_TIME = 538,
    ONSEND_RT_REPLY = 539,
    FLAGS_DECL = 540,
    AVPFLAGS_DECL = 541,
    ATTR_MARK = 542,
    SELECT_MARK = 543,
    ATTR_FROM = 544,
    ATTR_TO = 545,
    ATTR_FROMURI = 546,
    ATTR_TOURI = 547,
    ATTR_FROMUSER = 548,
    ATTR_TOUSER = 549,
    ATTR_FROMDOMAIN = 550,
    ATTR_TODOMAIN = 551,
    ATTR_GLOBAL = 552,
    ADDEQ = 553,
    SUBST = 554,
    SUBSTDEF = 555,
    SUBSTDEFS = 556,
    EQUAL = 557,
    LOG_OR = 558,
    LOG_AND = 559,
    BIN_OR = 560,
    BIN_AND = 561,
    BIN_XOR = 562,
    BIN_LSHIFT = 563,
    BIN_RSHIFT = 564,
    EQUAL_T = 565,
    DIFF = 566,
    MATCH = 567,
    INTEQ = 568,
    INTDIFF = 569,
    STREQ = 570,
    STRDIFF = 571,
    GT = 572,
    LT = 573,
    GTE = 574,
    LTE = 575,
    PLUS = 576,
    MINUS = 577,
    STAR = 578,
    SLASH = 579,
    MODULO = 580,
    NOT = 581,
    UNARY = 582,
    BIN_NOT = 583,
    DEFINED = 584,
    INTCAST = 585,
    STRCAST = 586,
    DOT = 587,
    STRLEN = 588,
    STREMPTY = 589,
    NUMBER = 590,
    ID = 591,
    NUM_ID = 592,
    STRING = 593,
    IPV6ADDR = 594,
    PVAR = 595,
    AVP_OR_PVAR = 596,
    EVENT_RT_NAME = 597,
    COMMA = 598,
    SEMICOLON = 599,
    RPAREN = 600,
    LPAREN = 601,
    LBRACE = 602,
    RBRACE = 603,
    LBRACK = 604,
    RBRACK = 605,
    CR = 606,
    COLON = 607
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 196 "core/cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;

#line 644 "core/cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CORE_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 661 "core/cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  467
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12102

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  353
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  910
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1699

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   607

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   627,   627,   630,   631,   632,   635,   636,   637,   638,
     639,   640,   640,   641,   641,   642,   643,   643,   644,   644,
     645,   645,   646,   647,   650,   666,   674,   688,   689,   695,
     696,   700,   701,   702,   703,   704,   707,   708,   709,   710,
     711,   712,   713,   716,   717,   720,   721,   722,   723,   724,
     728,   729,   730,   731,   732,   736,   737,   740,   741,   744,
     745,   747,   748,   751,   754,   760,   761,   765,   766,   769,
     770,   773,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   790,   791,   797,   798,   799,   800,   801,   802,   803,
     804,   805,   806,   807,   808,   809,   810,   813,   814,   817,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   882,   883,   886,   887,   890,   891,   892,   893,   896,
     897,   900,   901,   904,   905,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   952,   953,   960,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   989,   990,   997,   998,
    1005,  1006,  1013,  1014,  1021,  1022,  1029,  1030,  1037,  1038,
    1048,  1049,  1063,  1077,  1078,  1085,  1086,  1093,  1094,  1101,
    1102,  1111,  1112,  1121,  1122,  1129,  1130,  1137,  1138,  1145,
    1146,  1153,  1154,  1161,  1162,  1169,  1170,  1177,  1178,  1185,
    1186,  1193,  1194,  1201,  1202,  1209,  1210,  1217,  1218,  1225,
    1226,  1233,  1234,  1241,  1242,  1249,  1250,  1257,  1258,  1265,
    1267,  1274,  1275,  1286,  1287,  1294,  1295,  1302,  1303,  1310,
    1311,  1318,  1319,  1326,  1333,  1340,  1347,  1354,  1361,  1362,
    1369,  1370,  1377,  1378,  1385,  1386,  1393,  1394,  1401,  1402,
    1409,  1410,  1417,  1418,  1425,  1426,  1433,  1434,  1435,  1436,
    1439,  1440,  1443,  1444,  1445,  1446,  1458,  1470,  1483,  1496,
    1509,  1522,  1524,  1535,  1536,  1537,  1538,  1544,  1545,  1555,
    1556,  1557,  1558,  1559,  1560,  1567,  1568,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1599,  1600,  1607,  1608,  1615,
    1622,  1623,  1624,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1683,  1684,  1693,
    1694,  1703,  1704,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1736,  1737,  1739,  1741,  1742,
    1743,  1746,  1747,  1750,  1751,  1752,  1755,  1756,  1759,  1760,
    1761,  1769,  1774,  1779,  1784,  1789,  1792,  1797,  1805,  1811,
    1812,  1822,  1823,  1833,  1834,  1843,  1852,  1853,  1859,  1860,
    1866,  1870,  1871,  1874,  1903,  1918,  1919,  1923,  1934,  1935,
    1939,  1940,  1944,  1951,  1967,  1968,  1971,  1974,  1981,  1997,
    2001,  2002,  2007,  2007,  2014,  2015,  2017,  2016,  2039,  2044,
    2047,  2054,  2070,  2073,  2076,  2083,  2099,  2102,  2105,  2122,
    2125,  2126,  2127,  2128,  2129,  2130,  2152,  2153,  2154,  2155,
    2158,  2159,  2160,  2161,  2164,  2165,  2171,  2172,  2173,  2174,
    2175,  2176,  2177,  2180,  2181,  2182,  2183,  2190,  2191,  2192,
    2199,  2200,  2201,  2205,  2206,  2207,  2208,  2209,  2214,  2215,
    2218,  2219,  2220,  2226,  2228,  2230,  2231,  2233,  2235,  2237,
    2239,  2241,  2242,  2244,  2245,  2246,  2247,  2249,  2251,  2253,
    2255,  2257,  2259,  2260,  2296,  2298,  2300,  2302,  2305,  2307,
    2309,  2311,  2315,  2316,  2327,  2328,  2332,  2333,  2348,  2363,
    2364,  2367,  2368,  2369,  2381,  2382,  2397,  2412,  2414,  2421,
    2463,  2464,  2467,  2468,  2469,  2472,  2473,  2474,  2475,  2476,
    2477,  2478,  2479,  2482,  2490,  2500,  2517,  2524,  2531,  2538,
    2545,  2550,  2555,  2556,  2557,  2558,  2559,  2562,  2571,  2578,
    2603,  2619,  2620,  2625,  2644,  2653,  2665,  2680,  2681,  2684,
    2684,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,
    2705,  2708,  2709,  2712,  2719,  2722,  2729,  2735,  2736,  2745,
    2746,  2747,  2750,  2751,  2763,  2787,  2798,  2829,  2833,  2843,
    2857,  2869,  2870,  2872,  2873,  2874,  2888,  2889,  2890,  2891,
    2892,  2893,  2894,  2898,  2899,  2900,  2913,  2919,  2920,  2921,
    2922,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,
    2932,  2933,  2951,  2952,  2953,  2954,  2955,  2956,  2957,  2958,
    2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,  2967,  2969,
    2971,  2972,  2973,  2974,  2975,  2978,  2996,  2997,  2998,  3001,
    3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,  3021,
    3022,  3023,  3024,  3025,  3026,  3027,  3028,  3029,  3030,  3031,
    3032,  3033,  3034,  3035,  3043,  3051,  3059,  3067,  3075,  3083,
    3091,  3099,  3107,  3108,  3110,  3118,  3126,  3134,  3143,  3152,
    3161,  3169,  3178,  3186,  3187,  3189,  3192,  3193,  3194,  3195,
    3202,  3209,  3210,  3216,  3223,  3224,  3230,  3237,  3238,  3244,
    3247,  3250,  3251,  3252,  3255,  3256,  3257,  3266,  3275,  3276,
    3277,  3278,  3279,  3280,  3281,  3282,  3283,  3284,  3285,  3286,
    3287,  3288,  3289,  3290,  3291,  3292,  3296,  3300,  3301,  3302,
    3303,  3304,  3305,  3306,  3307,  3308,  3309,  3310,  3311,  3312,
    3313,  3314,  3315,  3316,  3317,  3318,  3319,  3320,  3321,  3322,
    3323,  3324,  3325,  3326,  3327,  3335,  3343,  3351,  3352,  3354,
    3356,  3367,  3368,  3369,  3385,  3386,  3387,  3391,  3394,  3395,
    3398,  3401,  3404,  3407,  3410,  3413,  3416,  3419,  3422,  3425,
    3426,  3427,  3430,  3431,  3432,  3432,  3465,  3467,  3469,  3470,
    3473,  3490,  3494,  3498,  3502,  3507,  3511,  3516,  3520,  3524,
    3528
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW",
  "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS",
  "SET_ADV_PORT", "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT",
  "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE",
  "DEFAULT", "WHILE", "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT",
  "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V", "FORK", "FORK_DELAY",
  "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "LOGCOLOR",
  "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE", "LOGENGINEDATA",
  "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE", "STRNAME",
  "ALIAS", "SR_AUTO_ALIASES", "DNS", "REV_DNS", "DNS_TRY_IPV6",
  "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF",
  "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_SLOW_QUERY_MS",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT", "DNS_USE_CACHE",
  "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS", "DNS_CACHE_NEG_TTL",
  "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL", "DNS_CACHE_MEM",
  "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP", "DNS_CACHE_REC_PREF",
  "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL", "DST_BLST_INIT",
  "USE_DST_BLST", "DST_BLST_MEM", "DST_BLST_TTL", "DST_BLST_GC_INT",
  "DST_BLST_UDP_IMASK", "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK",
  "DST_BLST_SCTP_IMASK", "IP_FREE_BIND", "PORT", "STAT", "CHILDREN",
  "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK",
  "CHECK_VIA", "PHONE2TEL", "MEMLOG", "MEMDBG", "MEMSUM", "MEMSAFETY",
  "MEMJOIN", "MEMSTATUSMODE", "SIP_PARSER_LOG", "CORELOG", "SIP_WARNING",
  "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER", "REPLY_TO_VIA",
  "LOADMODULE", "LOADPATH", "MODPARAM", "CFGENGINE", "MAXBUFFER",
  "SQL_BUFFER_SIZE", "USER", "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED",
  "DISABLE_TCP", "TCP_ACCEPT_ALIASES", "TCP_ACCEPT_UNIQUE",
  "TCP_CONNECTION_MATCH", "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT",
  "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME", "TCP_POLL_METHOD",
  "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT",
  "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE",
  "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX",
  "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT",
  "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2",
  "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL",
  "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL",
  "TCP_OPT_ACCEPT_HEP3", "TCP_OPT_ACCEPT_HAPROXY", "TCP_CLONE_RCVBUF",
  "TCP_REUSE_PORT", "DISABLE_TLS", "ENABLE_TLS", "TLSLOG", "TLS_PORT_NO",
  "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23",
  "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE",
  "TLS_CERTIFICATE", "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP",
  "ENABLE_SCTP", "SCTP_CHILDREN", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "SHM_MEM_SZ", "SHM_FORCE_ALLOC",
  "MLOCK_PAGES", "REAL_TIME", "RT_PRIO", "RT_POLICY", "RT_TIMER1_PRIO",
  "RT_TIMER1_POLICY", "RT_TIMER2_PRIO", "RT_TIMER2_POLICY",
  "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS", "PMTU_DISCOVERY",
  "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE", "PVBUFSLOTS", "PVCACHELIMIT",
  "PVCACHEACTION", "HTTP_REPLY_PARSE", "VERSION_TABLE_CFG",
  "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE", "CFG_DESCRIPTION", "SERVER_ID",
  "KEMI", "ONSEND_ROUTE_CALLBACK", "REPLY_ROUTE_CALLBACK",
  "EVENT_ROUTE_CALLBACK", "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "MSG_TIME", "ONSEND_RT_REPLY", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR", "AVP_OR_PVAR",
  "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE",
  "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "assign_stm", "cfg_var_id", "cfg_var_idn", "cfg_var",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "route_name",
  "route_main", "route_stm", "failure_route_main", "failure_route_stm",
  "route_reply_main", "onreply_route_stm", "$@6", "$@7",
  "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607
};
# endif

#define YYPACT_NINF -1169

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1169)))

#define YYTABLE_NINF -895

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2514,  -254,    21,    11,  -203,  -181,  -179,  -137,  -100,   -95,
   -1169,   -91,   -66,   -61,   -56,   -48,   -40,   -32,   -29,    15,
      16,    23,   209,   226,   258,   265,   384,   426,   458,   511,
     352,   726,   752,   771,   789,   797,   805,   808,   832,   835,
     842,   850,   864,   865,   866,   870,   871,   884,   915,   919,
     920,   923,   924,   925,   926,   927,   930,   940,   952,   954,
     955,   959,   960,   961,   964,   965,   528,   529,   544,   545,
     575,   582,   585,   598,   603,   608,   612,   616,   620,   621,
     652,   672,   683,   693,   708,   712,   733,   745,   101,    14,
      26,   147,   770,   802,   806,   807,   833,   834,   847,   852,
     859,   862,   863,   868,   873,   874,   880,   889,   897,   906,
     907,   928,   932,   933,   945,   950,   966,   974,   975,   976,
     951,   962,   963,   970,   980,   986,   996,  1003,  1007,  1016,
    1022,  1023,  1026,  1028,  1029,  1039,  1040,  1042,  1045,  1046,
    1047,  1048,  1065,  1066,  1068,  1083,  1084,  1095,  1096,  1098,
    1099,  1102,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1114,
    1118,  1119,  1120,  1121,  1122,  1123,  1124,   977,  1125,  1126,
    1171,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,   675,
    1181,  1187,  1188,  1189,  1190,  1191,  1192,  1194,  1195,  1220,
      13,    50,   183,   219,   227, -1169, -1169, -1169,  1015,  1617,
   -1169,   509,  1002,  1011,   999,  1024, -1169, -1169, -1169,  -262,
   -1169, -1169,   685, -1169, -1169, -1169, -1169,  -281, -1169,    52,
     312,   858,   216,   321,   326,   282,   336,   344,   345,   485,
     110,   236,   526,   255,   617,   256,   259,   260,   262,    61,
      88,   629,   649,   662, -1169,   701, -1169,   709, -1169,   721,
   -1169,  -266, -1169,  -266, -1169,  -266, -1169,  -266, -1169,   744,
   -1169,   749, -1169,   765, -1169,   780, -1169,   794, -1169,   822,
   -1169,   848, -1169,   875, -1169,   916, -1169,  1005, -1169,  1036,
   -1169,  1193, -1169,  1197, -1169,  1198, -1169,  1199, -1169,  1200,
   -1169,  1202, -1169,  1203, -1169,  1204, -1169,  1205, -1169,  1248,
   -1169,  1273, -1169,  1274, -1169,  1275, -1169,  1276, -1169,  1277,
   -1169,  1278, -1169,  1279, -1169,  1280,   322,   669,   673,   674,
     681,   682,   688,   691,   692,   323,   327,   329,   330,   331,
     337,   338,   346,   694,   696,   263,   264,   698, -1169, -1169,
   -1169,   267, -1169, -1169,   849, -1169,   268, -1169,   699,   702,
     225,   228,   237,   241,   242,   703,   704,   705,   706,   707,
     711,   473,   488,   546,   248,   713,   714,   715,   716,    20,
     717,   722, -1169,  1281, -1169,  1285, -1169,  1286, -1169,  1287,
     723,   728,   729,   730,   731,   732,   734,   735,   736,   739,
     740,   741,   742,   743,   750,   751,   753,   754,    81,   755,
     757,   758,   760,   270,   271,   274,   761,   762,   763,    66,
     766,   767,   768,   776,   777,   778,   779,   781,   782,   783,
     784,   785,   790,   791,   792,   251,   159, -1169,  1288,   793,
     795,   796,   798,   803,   804,   810,   275,   811,   813,   815,
    -101,   561,  1289,  1291,   595,   610,   816,   818,   820,   821,
     824, -1169, -1169, -1169, -1169,   725,   846, -1169, -1169, -1169,
     917, -1169, -1169, -1169, -1169, -1169, -1169, -1169,  -254, -1169,
      24,    17,  1182, -1169,    44,  1183, -1169,    65,  1184, -1169,
      82,  1283, -1169,    31,   856, -1169,     7,  1293, -1169, -1169,
   -1169, -1169,  1306, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169,  1294, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169,  1325, -1169, -1169, -1169, -1169,   654,  1185, -1169,  1311,
    1312,  1149,   -34, -1169, -1169, -1169, -1169, -1169,  -198, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,  1322,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,  1325,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169,  1221,  1223,  1224,  1225, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169,  -246,  1331,  -246, -1169,  -281,
   -1169, 11758, -1169,  -281, 11758, -1169,  -281, 11758, -1169,  -281,
   11758, -1169,  1326, -1169, -1169, -1169,  1365,  1319, 11758,    18,
   -1169,  1335,  1328,  1327,  1323,   355,  1038, -1169,   654,  1360,
     303,   306,  1361,   276,   277,   281,   283, -1169, -1169, -1169,
    1350,    46,    49,    60,    62,    67, 10673, 11018, 11103, -1169,
      71,    90,    94,  1355,    96,    97,    99,   112,   115,   118,
     126,   146,  1357,   157,   166,   167,   168,  1358,  1359,  1362,
    1363,  1380, 11188,   173,   174,   179,  1381,  1424,  1498,  1499,
    6353, 11188,   180,   185,   188,   189,   191, -1169, -1169, -1169,
   -1169,   193, -1169, -1169, -1169,    72,  3616, -1169, -1169, -1169,
   -1169,  1069, -1169, -1169, -1169, -1169, -1169,  1404,  1502,   200,
   -1169,  1503,  1535,  3691,  1538,  3771,  1539,  4037,  1540,    95,
    1375,  4117, -1169,  1544,  1572,   654, -1169, -1169, -1169, -1169,
   -1169, -1169,  1553,   -51, -1169, -1169, -1169, -1169, -1169, -1169,
    1563, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,  1560,
   -1169,    40, -1169,    83, -1169,   121, -1169,   127, -1169,   152,
     690, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169,   -71, -1169,   -71, -1169,   869, -1169, -1169,  1294,
   -1169, -1169,  6440,  6527,  6874,  1562,  1564, -1169,  5485, 11687,
   -1169,   885, -1169,   896, -1169,   908, -1169, -1169, -1169,  1069,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169,  6961,  1372,  5832,
    1372,  5919,  1372, -1169,   116, -1169,   284, -1169,  7048,  1571,
   -1169,   285, -1169,   286, -1169,   289, -1169,   290, -1169,   825,
   -1169,   827, -1169,  1566, -1169,   214,  1567, -1169,   293, -1169,
     294, -1169,   295, -1169,   296,  1568,  1569,  1570,   195,   881,
    7395, 10606, -1169,   161, -1169,   828, -1169,   144,  1574,  1575,
    1599,  1600, -1169,  1127, 10606, -1169,   297, -1169,   299, -1169,
    -138, -1169,   -88, -1169,   -33, -1169,  1601, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169,  1614, -1169,  1602, -1169, 11188, -1169, -1169,   215,
   -1169,  1603, -1169,  1605, -1169,  1607, -1169,  1608, -1169,  1680,
    1681,     7, -1169, 11758,  1621, -1169,  -209,  1619,  1623,  -192,
   11758,  1615,  -189, -1169,   -31, -1169,   -10,   636,  1620,   499,
     550,   570,   651,  1636,   637,   668,   710,   958,  1637,   826,
     888,   898,   967,  1638,   903,   938,   948,  1000, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169,  7482,  5299,  5392, -1169,  1243,
    1626, -1169, -1169, -1169, -1169, -1169, -1169,  7569,  7916,  1639,
   -1169,  1657,  1662,  1664,  1683,  1196,  1641,  1648,  4186, -1169,
    8003, -1169, -1169, -1169, -1169, -1169,  8090,  8437, -1169,  2848,
    1658, -1169, -1169,  8524,  8611,  8958,  9045, 11188, 11188, 11188,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169,  9132,  9479,  9566,  9653, 10000, 10087, 10174, -1169, -1169,
    1642,  1666,  1665,  1668,  1679,  1678,    36,  1239,  1682,  1684,
    1692,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1720,  1731,
    1733, -1169,  1734, -1169,  1735, -1169,  1737,  1746,  1747,  1751,
    1752,  1753,  1761,  1774, -1169, -1169, -1169,  1775,  1776, -1169,
    1777,  1778, 11758,  1964, -1169,  1779,  1780,  1789,  1800,  1802,
    1676,  1796,  1804, -1169, -1169, -1169, -1169,    29, -1169,  1806,
    1817,  1816,  1820,  1821,  1822,  1830,  1843,  1844,  1845, 11188,
    1855,  1842,  1372,   949, -1169,  1069, -1169,  1850, -1169, 11758,
   11758, 11758, 11758,  1856,  1865,  1912,  4261,  1884, -1169, -1169,
    2107,  1873,  1875,  4383, -1169,   506, -1169,  1894, -1169,  1895,
   -1169,   114,   117,  1899, -1169, -1169,   554, -1169,  1900, -1169,
    1901, -1169,  1908, -1169, -1169,   663, -1169,  1909, -1169,  1910,
   -1169,  1911, -1169, -1169,   664, -1169,  1913, -1169,  1914, -1169,
    1915, -1169, -1169,   687, -1169,  1916, -1169,  1917, -1169,  1919,
   -1169, -1169,  2035,  1071, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169,  1071, -1169, -1169,  1071, -1169, -1169, -1169,
    1898, -1169,  1923,  1918,  1282,  1920,  1618, -1169, -1169, -1169,
   -1169, -1169, -1169,  2104,  1071, -1169,  1071, -1169,  1057, -1169,
    2173,  1325,  1966,  1932, -1169,  -197,  1071,  -257, -1169,  2512,
   -1169,  2838, -1169,  2986, -1169,  1146,  1257,  3003,  1329, -1169,
     464, -1169,   464, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
    1071, -1169,  1057, -1169,  1921, -1169, -1169,  1922, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,  4607, 11618,
   -1169, -1169, -1169, -1169, -1169,   628,   654, -1169,  1944,  6006,
    1905, -1169, -1169,   855, -1169, 11533, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169,  1372,   968, -1169, -1169, -1169,  -246,
   -1169, -1169,   254,  4729,  4798,  4873,  4953, -1169, -1169,  -174,
   -1169,  1926,  1924, -1169, -1169, -1169,  1948,  1949,  1950,  1951,
   -1169, -1169, -1169, -1169,  1952,  1954,  1955,  1956,  1958,  1959,
    1960,  1963,  1969,  1970,  1971,  1972,  1974,  1975,  1976,  1978,
    1979,  1980,  1981,  1982,  1983,  -114,  1626, -1169, -1169, -1169,
   -1169,     5,  1984,  1985,  1986, -1169, -1169, -1169, -1169,  1906,
   -1169,  1977, 10521,  2009,  1372, 11758, -1169, -1169,  1987,  2278,
   11188, -1169,  1988,  1990,  1991, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,  2012,  2013,
   -1169, -1169,  1325, -1169, -1169, -1169, -1169,  -209, 11758,  2014,
    2015,  2935,  3004, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1169,  3073, 11758, 11758, -1169,  3201,  3425,  3547
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     457,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   456,    22,    23,     0,     0,
       4,     0,     0,     0,     0,     0,     8,     9,     6,     0,
     454,    10,     0,    15,     7,   455,   504,     0,   505,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   105,     0,   107,     0,   109,     0,
     111,     0,   113,     0,   115,     0,   117,     0,   119,     0,
     121,     0,   123,     0,   125,     0,   127,     0,   129,     0,
     131,     0,   133,     0,   135,     0,   137,     0,   139,     0,
     141,     0,   145,     0,   143,     0,   147,     0,   149,     0,
     151,     0,   153,     0,   155,     0,   157,     0,   159,     0,
     161,     0,   163,     0,   165,     0,   167,     0,   169,     0,
     171,     0,   173,     0,   175,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   469,   468,
     471,     0,   470,   476,     0,   478,     0,   477,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   269,     0,   271,     0,   273,     0,   275,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   395,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    60,    66,    65,    59,    61,    63,    68,    71,    67,
      69,   521,   520,   523,   522,   525,   524,     1,     5,     3,
       0,     0,     0,    12,     0,     0,    14,     0,     0,    17,
       0,     0,    19,     0,     0,    21,     0,     0,   502,   487,
     488,   489,     0,   445,   444,   443,   442,   447,    31,    32,
      33,    34,    35,   446,   449,     0,    57,   448,   451,   450,
     453,   452,    73,    72,    75,    74,    77,    76,    79,    78,
      81,    80,    83,    82,    85,    84,    87,    86,    89,    88,
      91,    90,    93,    92,    95,    94,    97,    96,    99,    98,
     351,   603,   601,   602,    25,   484,     0,     0,    30,    50,
       0,    55,   345,    24,   481,   485,   482,   604,    26,   353,
     352,   355,   354,   101,   100,   103,   102,   104,   106,   108,
     110,   112,   114,   116,   118,   120,   122,   124,   126,   128,
     130,   132,   134,   136,   138,   140,   144,   142,   146,   148,
     150,   152,   154,   156,   158,   160,   162,   164,   166,   168,
     170,   172,   174,   177,   176,   183,   178,   185,   184,   187,
     186,   189,   188,   191,   190,   193,   192,   195,   194,   197,
     196,   199,   198,   201,   200,   203,   202,   205,   204,   207,
     206,   209,   208,   211,   210,   213,   212,   215,   214,   338,
     337,   340,   339,   342,   341,   344,   343,   473,   472,     0,
     480,   479,   180,   179,   182,   181,   220,   219,   218,   223,
     222,   221,   226,   225,   224,   229,   228,   227,   232,   231,
     230,   234,   233,   236,   235,   238,   237,   240,   239,   242,
     241,   244,   243,   246,   245,   248,   247,   250,   249,   253,
     251,   252,   255,   254,   257,   256,   259,   258,   261,     0,
     260,   263,   262,   265,   264,   267,   266,   268,   270,   272,
     274,   277,   276,   279,   278,   281,   280,   283,   282,   285,
     284,   287,   286,   289,   288,   291,   290,   293,   292,   295,
     294,   297,   296,   299,   298,   301,   300,   303,   302,   305,
     304,   307,   306,   309,   308,   311,   310,   316,   312,   313,
     314,   315,   328,   327,   330,   329,   318,   317,   320,   319,
     322,   321,   324,   323,   326,   325,   332,   331,   334,   333,
     336,   335,   357,   356,   359,   358,   361,   360,   363,   362,
     365,   364,   367,   366,   369,   368,   371,   370,   373,   372,
     375,   374,   377,   376,   379,   378,   381,   380,   383,   382,
     385,   384,   387,   386,   390,   388,   389,   393,   391,   392,
     394,   397,   396,   399,   398,   401,   400,   403,   402,   405,
     404,   407,   406,   409,   408,   217,   216,   411,   410,   413,
     412,   415,   414,     0,     0,     0,     0,   425,   424,   426,
     427,   431,   430,   429,   428,   433,   432,   435,   434,   437,
     436,   439,   438,   441,   440,     0,     0,     0,   494,     0,
     495,     0,   499,     0,     0,   512,     0,     0,   516,     0,
       0,   519,     0,   459,   460,   458,     0,     0,     0,     0,
      58,     0,    27,     0,     0,     0,     0,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    62,    64,    70,
       0,     0,     0,     0,     0,     0,   906,   903,   907,   910,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   859,   861,   863,
     866,     0,     0,     0,     0,     0,   880,   882,   884,   886,
       0,     0,     0,     0,     0,     0,     0,   736,   737,   738,
     663,     0,   675,   676,   621,     0,     0,   613,   616,   617,
     618,     0,   667,   668,   678,   679,   680,     0,     0,     0,
     609,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   508,     0,     0,     0,    29,   486,    54,    44,
      43,    51,    52,   349,   346,   608,   603,   606,   607,   605,
       0,   417,   416,   419,   418,   421,   420,   423,   422,     0,
     749,     0,   771,     0,   782,     0,   793,     0,   760,     0,
       0,   547,   548,   549,   560,   553,   561,   554,   559,   551,
     558,   550,     0,   552,     0,   555,     0,   556,   649,   695,
     693,   694,     0,     0,     0,     0,     0,   682,     0,     0,
     681,     0,   557,     0,   562,     0,   688,   687,   686,     0,
     669,   671,   670,   683,   684,   685,   696,     0,   905,     0,
     902,     0,   909,   797,     0,   814,     0,   818,     0,     0,
     822,     0,   841,     0,   844,     0,   825,     0,   831,     0,
     828,     0,   834,     0,   837,     0,     0,   850,     0,   853,
       0,   847,     0,   856,     0,     0,     0,     0,     0,     0,
       0,     0,   872,     0,   875,     0,   878,     0,     0,     0,
       0,     0,   641,     0,     0,   889,     0,   892,     0,   801,
       0,   804,     0,   807,     0,   896,     0,   622,   615,   614,
     492,   612,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,     0,   661,   664,   677,     0,   620,   812,     0,
     619,     0,   497,     0,   510,     0,   514,     0,   465,   461,
     462,     0,   503,     0,     0,    28,     0,     0,     0,     0,
       0,     0,     0,   596,     0,   739,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   566,   526,
     527,   535,   528,   529,   534,     0,     0,     0,   591,     0,
       0,   734,   717,   719,   698,   720,   699,     0,     0,     0,
     904,   669,   670,   684,   685,     0,     0,     0,     0,   570,
       0,   575,   530,   531,   532,   533,     0,     0,   587,     0,
     664,   718,   697,     0,     0,     0,     0,     0,     0,     0,
     536,   537,   542,   538,   539,   540,   541,   543,   544,   545,
     546,     0,     0,     0,     0,     0,     0,     0,   901,   908,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   833,     0,   836,     0,   839,     0,     0,     0,     0,
       0,     0,     0,     0,   858,   860,   862,     0,     0,   865,
       0,     0,     0,   623,   610,     0,     0,     0,     0,     0,
      45,     0,     0,   879,   881,   883,   885,     0,   643,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   897,
       0,     0,   735,     0,   674,     0,   672,     0,   673,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,   350,
     347,     0,     0,     0,   750,     0,   748,     0,   741,     0,
     742,     0,     0,     0,   740,   772,     0,   770,     0,   763,
       0,   764,     0,   762,   783,     0,   781,     0,   774,     0,
     775,     0,   773,   794,     0,   792,     0,   785,     0,   786,
       0,   784,   761,     0,   759,     0,   752,     0,   753,     0,
     751,   565,     0,   563,   581,    36,    37,    38,    39,    40,
      41,    42,   579,   580,   578,   576,   577,   590,   588,   589,
     644,   648,   650,     0,     0,     0,     0,   692,   714,   691,
     690,   689,   569,     0,   567,   574,   572,   573,   571,   586,
       0,    57,     0,   594,   582,   584,   583,     0,   731,   713,
     730,   712,   726,   705,   727,   706,   707,   708,   709,   721,
     700,   722,   701,   723,   702,   724,   703,   725,   704,   729,
     711,   728,   710,   798,     0,   795,   815,     0,   819,   817,
     816,   820,   823,   821,   842,   840,   845,   843,   826,   824,
     832,   830,   829,   827,   838,   835,   851,   849,   854,   852,
     848,   846,   857,   855,   867,   864,   869,   868,     0,     0,
     871,   870,   874,   873,   877,     0,     0,   876,     0,     0,
       0,   640,   638,     0,   890,     0,   893,   891,   799,   800,
     802,   803,   805,   806,   900,     0,   899,   662,   666,     0,
     811,   664,     0,     0,     0,     0,     0,   463,   464,     0,
     507,     0,     0,   474,   475,   493,     0,     0,     0,     0,
     600,   598,   599,   597,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   732,   715,   733,
     716,     0,     0,     0,     0,   611,   624,    49,    46,    47,
     642,     0,     0,     0,   625,   631,   639,   637,    57,     0,
       0,   895,     0,     0,     0,   498,   511,   515,   518,   466,
     467,   483,   348,   746,   747,   744,   745,   743,   768,   769,
     766,   767,   765,   779,   780,   777,   778,   776,   790,   791,
     788,   789,   787,   757,   758,   755,   756,   754,     0,     0,
     647,   595,   593,   592,   665,   796,   813,     0,   634,     0,
       0,     0,     0,   887,   888,   898,   810,   809,   808,   646,
     645,    48,     0,   635,   629,   636,     0,     0,     0
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1169, -1169, -1169,  2065, -1169, -1169, -1169, -1169, -1169,  -404,
    1352,  1382,  -219,  1049, -1168, -1169, -1169,  -201,  -222, -1169,
    1412, -1169,  -190, -1169,  1507, -1169, -1169, -1169,  1201, -1169,
   -1169,  -975,  1997,  1823,  1999,  -660, -1169, -1169, -1169, -1169,
   -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169, -1169,
   -1169, -1025, -1169,  -919, -1169, -1169,  1150, -1169, -1169, -1169,
    1154, -1169, -1169,   287,  -602, -1169,  -279, -1120,  -854,  -763,
   -1169,   764,   831, -1169, -1169, -1169,   786, -1169, -1169, -1169,
   -1169,  1027,  -760,  -504,  -844, -1169,  -790, -1169, -1169, -1169,
    -423,  -818, -1169, -1169, -1169, -1169,    80,  -990, -1169, -1169,
   -1169, -1169,   759, -1169
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   198,   199,   200,   201,   202,   203,   204,   205,   548,
     883,   549,   550,  1432,   991,  1332,   551,   552,  1050,   206,
     454,   455,   456,   207,   459,   460,   208,   209,   876,   210,
     211,   553,   554,   555,   556,   492,   472,   473,   475,   476,
     212,   213,   878,   983,   478,   479,   481,   482,   484,   485,
     214,  1214,  1247,  1215,  1276,  1277,  1051,  1052,  1053,  1054,
    1055,  1056,  1464,  1187,   557,   558,  1057,  1323,   956,   957,
     958,  1623,  1542,  1543,   959,   960,  1441,  1442,  1058,  1220,
    1152,  1153,  1154,  1059,  1060,  1061,  1062,   964,  1063,  1357,
    1064,  1065,  1156,   967,  1066,  1067,  1235,   968,   969,   970,
    1136,  1555,  1556,   971
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     507,   458,   503,   513,  1338,   773,  1671,  1216,  1368,  1217,
     973,  1219,   218,   975,   451,   340,   977,   962,   860,   982,
     962,   701,   216,   962,   981,   858,   962,   343,  1246,   570,
    1538,   571,   871,   572,   962,   573,  1186,  1135,  1191,   560,
    1196,  1181,  1201,   966,  1206,   862,   966,  1010,   215,   966,
    1012,   457,   966,   493,   489,   490,   505,   491,  1236,  1177,
     966,  1014,   540,  1016,   873,   505,   865,   772,  1018,   506,
     486,   963,  1073,  1137,   963,   888,   889,   963,   506,  1236,
     963,  1236,   747,   868,  1188,  1539,  1540,   487,   963,   559,
     452,  1075,   453,  1558,   604,  1077,  1168,  1080,  1082,   219,
    1084,  1182,   338,   622,   624,   626,   628,   630,   632,   634,
     636,   522,   962,  1086,   989,  1580,  1088,  1280,  1582,  1090,
    1236,   220,  1193,   221,   890,  1381,   990,  1092,  1198,   962,
     505,   962,  1240,   962,   891,  1382,  1249,   962,   966,   684,
     686,   688,   882,   506,  1189,  1329,  1371,  1094,   345,   498,
     499,   500,   501,  1203,  1375,   966,  1376,   966,  1097,   966,
     807,  1639,  1325,   966,  1640,   222,   963,  1099,  1101,  1103,
     833,   834,   835,   836,  1112,  1114,   498,   499,   500,   501,
    1116,  1125,  1194,   963,   461,   963,  1127,   963,  1199,  1129,
    1131,   963,  1133,  1141,  1135,  1238,  1317,  1343,   452,   900,
     453,  1158,   223,   972,  1231,   962,   974,   224,   505,   976,
    1141,   225,  1141,  1204,  1141,  1302,  1353,   504,  1141,   838,
     463,   506,   842,   844,  1668,  1231,   656,  1231,   465,   659,
    1234,   966,   498,   499,   500,   501,   226,   524,   662,  1209,
    1210,   227,   665,   668,  1212,  1213,   228,  1345,   452,   689,
     453,  1234,   804,  1234,   229,  1633,   528,   532,  1232,   963,
     534,   536,   230,   538,   641,   643,  1231,   962,   647,   650,
     231,   760,   762,   232,  1463,   764,   825,  1001,  1003,  1232,
     962,  1232,  1005,   512,  1007,  1283,  1289,  1291,   997,   999,
    1293,  1295,  1234,   966,  1306,  1308,  1310,  1312,  1339,  1250,
    1341,  1178,  1347,   452,   995,   453,   966,   998,   748,   749,
     750,   751,  1377,   495,  1378,  1356,   341,   233,   234,  1366,
    1232,   963,   508,   603,   621,   235,  1373,   510,   623,   962,
     625,   627,   629,  1379,   963,  1380,   962,   514,   631,   633,
    1672,  1358,   874,   875,   545,   516,   518,   635,  1324,   452,
     887,   453,   342,   244,   547,   966,   988,   961,  -501,   545,
     961,  1324,   966,   961,  -491,  -506,   961,  1618,  -500,   547,
     217,  -490,   344,   859,   961,   699,  1183,  1541,  1184,   545,
    -517,  1499,  -894,   963,   502,  1185,   452,   494,   453,   547,
     963,  -496,  1011,   863,   962,  1013,   541,   542,   543,   544,
     545,   541,   542,   543,   544,   545,  1015,   546,  1017,  1616,
     547,   502,  -509,  1019,   866,   547,  1138,  1074,   699,  1183,
     966,  1190,   545,   541,   542,   543,   544,   545,  1219,  -513,
    1169,   869,   547,  1170,   546,  1219,  1076,   547,   965,   339,
    1078,   965,  1081,  1083,   965,  1085,   523,   965,   963,   346,
    1581,  1281,   961,  1583,  1282,   965,   699,  1183,  1087,  1195,
     545,  1089,   699,  1183,  1091,  1200,   545,   502,  1528,   961,
     547,   961,  1093,   961,   683,  1141,   547,   961,   962,   541,
     542,   543,   544,   545,   993,   347,   520,   699,  1183,   685,
    1205,   545,  1095,   547,   808,   809,   541,   542,   543,   544,
     545,   547,   950,  1098,   966,  1563,  1564,  1565,  1566,  1691,
     547,   236,  1100,  1102,  1104,   962,   962,   962,   962,  1113,
    1115,   462,   962,   470,   471,  1117,  1126,   526,   237,   962,
    1318,  1128,   963,   965,  1130,  1132,   505,  1134,   505,  -894,
    1319,   966,   966,   966,   966,   961,  1159,   687,   966,   506,
     965,   506,   965,  1354,   965,   966,   953,   464,   965,  1303,
     238,   657,   837,   658,   660,   466,   661,   239,  1576,   963,
     963,   963,   963,   663,   525,   664,   963,   666,   669,   667,
     670,   882,   955,   963,   690,   955,   691,   805,   955,   806,
     452,   955,   453,   529,   533,  1561,   841,   535,   537,   955,
     539,   642,   644,  1141,   505,   648,   651,   961,   761,   763,
    1141,   843,   765,   826,  1002,  1004,  1585,   506,   530,  1006,
     961,  1008,  1284,  1290,  1292,  1233,   965,  1294,  1296,  1617,
     561,  1307,  1309,  1311,  1313,  1340,  1673,  1342,   996,   542,
     543,   996,   542,   543,   505,   505,  1233,   496,  1233,   505,
     563,   505,   505,   505,   245,  1355,   509,   506,   506,   505,
     505,   511,   506,   565,   506,   506,   506,   458,   505,   961,
     605,   515,   506,   506,   607,   609,   961,   955,   989,   517,
     519,   506,   611,   613,   962,   962,   240,  1233,   965,   615,
     990,  1208,   617,   619,   955,   637,   955,   639,   955,   645,
     652,   965,   955,   654,   671,   673,   675,   677,   679,  1326,
     966,   966,   681,  1330,   692,   694,   696,   698,   703,   962,
     962,   962,   962,   705,   711,  1590,  1595,   246,   241,   713,
     715,   717,   719,   721,   961,   723,   725,   727,   963,   963,
     729,   731,   733,   735,   737,   966,   966,   966,   966,  1600,
     965,   739,   741,   248,   743,   745,   752,   965,   754,   756,
     242,   758,   766,   768,   770,  1141,  1324,   774,   776,   778,
     955,  1682,   250,   963,   963,   963,   963,   780,   782,   784,
     786,   962,   788,   790,   792,   794,   796,  1273,  1274,  1275,
     252,   798,   800,   802,   811,   505,   813,   815,   254,   817,
    1141,  1141,  1141,  1141,   819,   821,   256,   966,   506,   258,
     505,   823,   827,   243,   829,   965,   831,   845,   961,   847,
     521,   849,   851,   506,  1692,   853,  1297,  1696,  1299,  1327,
     316,   317,   955,   260,   962,   963,   262,   962,   962,  1697,
    1698,  1577,  1386,   264,  1387,   955,   318,   319,   962,   962,
     962,   266,   962,   962,   962,   961,   961,   961,   961,   497,
     966,   527,   961,   966,   966,   268,   270,   272,   505,   961,
    1218,   274,   276,  1304,   966,   966,   966,   320,   966,   966,
     966,   506,  1320,   505,   321,   278,  1239,   322,   963,  1586,
    1321,   963,   963,  1388,   955,  1389,   506,  1241,  1331,   965,
     323,   955,   963,   963,   963,   324,   963,   963,   963,  1248,
     325,  1539,  1540,  1390,   326,  1391,   280,   505,   327,  1141,
     282,   284,   328,   329,   286,   288,   290,   292,   294,  1141,
     506,   296,   505,  1141,  1141,  1141,   965,   965,   965,   965,
    1344,   298,  1346,   965,  1348,   506,   498,   499,   500,   501,
     965,   989,   531,   300,   330,   302,   304,  1372,  1381,   955,
     306,   308,   310,   990,   562,   312,   314,   372,  1382,   498,
     499,   500,   501,  1381,   331,   374,   376,   378,   427,  1383,
    1395,  1384,  1396,  1382,   564,   332,  1068,  1070,  1072,   541,
     542,   543,   544,   545,  1392,   333,  1393,   566,  1591,  1596,
    1209,  1210,  1211,   547,   606,  1212,  1213,   440,   608,   610,
     334,  1397,  1111,  1398,   335,   467,   612,   614,   474,   480,
    1123,  1124,  1601,   616,   961,   961,   618,   620,   247,   638,
     477,   640,   488,   646,   653,   336,   567,   655,   672,   674,
     676,   678,   680,   955,   568,   483,   682,   337,   693,   695,
     697,   699,   704,  1399,   249,  1400,   569,   706,   712,   961,
     961,   961,   961,   714,   716,   718,   720,   722,   855,   724,
     726,   728,   348,   251,   730,   732,   734,   736,   738,   574,
     955,   955,   955,   955,   575,   740,   742,   955,   744,   746,
     753,   253,   755,   757,   955,   759,   767,   769,   771,   255,
     576,   775,   777,   779,   349,   965,   965,   257,   350,   351,
     259,   781,   783,   785,   787,   577,   789,   791,   793,   795,
     797,   961,  1222,  1224,  1226,   799,   801,   803,   812,   578,
     814,   816,  1619,   818,   261,   352,   353,   263,   820,   822,
     965,   965,   965,   965,   265,   824,   828,  1252,   830,   354,
     832,   846,   267,   848,   355,   850,   852,   579,  1287,   854,
    1298,   356,  1300,  1328,   357,   358,   269,   271,   273,  1404,
     359,  1405,   275,   277,   961,   360,   361,   961,   961,  1209,
    1210,   502,   362,   580,  1212,  1213,   279,   649,   961,   961,
     961,   363,   961,   961,   961,  1209,  1210,  1211,   856,   364,
    1212,  1213,   965,  1626,   502,   872,  1209,  1210,   365,   366,
     581,  1212,  1213,  1242,  1243,  1244,  1245,   281,  1209,  1210,
    1211,   283,   285,  1212,  1213,   287,   289,   291,   293,   295,
     367,  1406,   297,  1407,   368,   369,  1352,   498,   499,   500,
     501,  1408,   299,  1409,  1437,  1612,  1413,   370,  1414,   955,
     955,   582,   371,   380,   301,   965,   303,   305,   965,   965,
     857,   307,   309,   311,   381,   382,   313,   315,   373,   965,
     965,   965,   383,   965,   965,   965,   375,   377,   379,   428,
    1381,  1415,   384,  1416,   955,   955,   955,   955,   385,  1381,
    1382,  1417,  1559,  1418,  1560,  1423,  1433,  1436,   386,  1382,
    1192,  1401,  1197,  1402,  1202,   387,  1207,  1444,  1446,   388,
    1410,  1630,  1411,  1631,  1021,  1022,  1023,  1024,   389,  1026,
    1454,  1028,  1381,  1030,   390,   391,  1456,  1458,   392,  1466,
     393,   394,  1382,  1469,  1471,  1473,  1475,  1476,  1477,  1478,
     583,   395,   396,  1419,   397,  1420,   955,   398,   399,   400,
     401,  1480,  1482,  1484,  1486,  1488,  1490,  1492,  1142,  1143,
    1144,  1145,  1146,  1147,  1148,  1149,  1150,   402,   403,  1632,
     404,   584,  1634,   541,   542,   543,   544,   545,  1271,  1272,
    1273,  1274,  1275,  1669,   546,   405,   406,   547,  1267,  1268,
    1269,  1270,  1271,  1272,  1273,  1274,  1275,   407,   408,   955,
     409,   410,   955,   955,   411,  1151,   412,   413,   414,   415,
     416,   417,   418,   955,   955,   955,   419,   955,   955,   955,
     420,   421,   422,   423,   424,   425,   426,   429,   430,  1554,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,
    1273,  1274,  1275,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,
    1274,  1275,   502,   431,  1337,   432,   433,   434,   435,   436,
     437,   438,   439,   441,   541,   542,   543,   544,   545,   442,
     443,   444,   445,   446,   447,   546,   448,   449,   547,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,
    1274,  1275,   450,   893,   545,   894,   895,   896,   585,   861,
     864,   867,   586,   587,   588,   589,  1465,   590,   591,   592,
     593,  1448,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1258,  1259,  1260,  1261,  1262,
    1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,
    1273,  1274,  1275,   594,  1500,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,   595,   596,
     597,   598,   599,   600,   601,   602,   707,    -2,   468,  1624,
     708,   709,   710,   810,   839,  1629,   840,  1608,   877,   880,
     870,   -11,   -11,   -13,     2,     3,   -16,   -18,   -20,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,     4,   879,   881,     5,     6,
       7,     8,     9,   885,   886,   892,   898,   979,   978,   980,
     984,   985,   986,   987,    10,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,   994,  1000,
    1009,  1079,  1624,  1096,  1105,  1106,  1155,  1171,  1107,  1108,
    1554,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,  1109,  1118,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
    1119,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,  1120,  1121,  1157,  1160,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,  1161,   178,   179,  1163,  1165,
    1167,  1173,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,  1174,  1176,  1179,  1180,  1227,  1288,
    1228,  1301,  1305,  1314,  1315,  1316,   192,   193,   194,  1333,
    1334,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
    1272,  1273,  1274,  1275,  1335,  1336,  1350,  1349,  1363,  1364,
    1359,  1351,  1360,   195,  1361,  1362,  1367,  1369,  1370,  -667,
    1374,   196,  1440,  1610,  -668,  1385,  -679,  1135,   197,  -596,
    -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,
    -596,  1394,  1403,  1412,  1447,  -680,  1449,  1493,  -596,  -596,
    -596,  -596,  -596,  -596,  -596,  -596,  1450,  -596,  -596,  -596,
    -596,  -596,  -596,  -596,  -596,  -596,  -596,  1467,  -596,  1494,
    1495,  1529,  -596,  1496,  -596,  -596,  -596,  -596,  -596,  -596,
    -596,  -596,  1497,  1498,  -596,  -596,  -596,  1501,  1535,  1502,
    -596,  -596,  -596,  -596,  -596,  -596,  1135,  1503,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    1504,  1505,  1506,  1507,  1508,  1509,  1510,  -564,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  1511,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  1512,  -564,  1513,  1514,
    1515,  -564,  1516,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  1517,  1518,  -564,  -564,  -564,  1519,  1520,  1521,  -564,
    -564,  -564,  -564,  -564,  -564,  1218,  1522,  -568,  -568,  -568,
    -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,  1523,
    1524,  1525,  1526,  1527,  1530,  1531,  -568,  -568,  -568,  -568,
    -568,  -568,  -568,  -568,  1532,  -568,  -568,  -568,  -568,  -568,
    -568,  -568,  -568,  -568,  -568,  1533,  -568,  1534,  1536,  1537,
    -568,  1544,  -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,
    1545,  1546,  -568,  -568,  -568,  1547,  1548,  1549,  -568,  -568,
    -568,  -568,  -568,  -568,  1218,  1550,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  1551,  1552,
    1553,  1151,  1558,  1562,  1567,  -585,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  1568,  -585,  -585,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  1569,  -585,  1571,  1572,  1573,  -585,
    1574,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  1578,
    1579,  -585,  -585,  -585,  1584,  1587,  1588,  -585,  -585,  -585,
    -585,  -585,  -585,  1589,  1592,  1593,  1594,  1605,  1597,  1598,
    1599,  1602,  1603,  -596,  1604,  1606,  1611,  1625,  1677,  1613,
    1614,  1641,  1642,  1607,   469,  1609,  1435,   897,   992,  -596,
    -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,
    -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,  -596,
    -596,  -596,  1620,  1643,  1644,  1645,  1646,  1647,  -596,  1648,
    1649,  1650,  -596,  1651,  1652,  1653,  -596,  -596,  1654,  -596,
    -596,  -596,  -894,  -596,  1655,  1656,  1657,  1658,  -596,  1659,
    1660,  1661,  -564,  1662,  1663,  1664,  1665,  1666,  1667,  1678,
    1675,  1676,  1683,  1686,  1674,  1687,  1688,  1175,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  1681,  1689,  1690,   899,   700,  1693,  1694,   702,  1438,
     884,  -564,  1365,  1439,  1627,  -564,  -564,  1557,  -564,  -564,
    -564,  -894,  -564,     0,     0,     0,  1680,  -564,     0,  1685,
       0,  -568,  1670,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -568,  -568,  -568,
    -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,
    -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,  -568,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -568,     0,     0,     0,  -568,  -568,     0,  -568,  -568,  -568,
       0,  -568,     0,     0,     0,     0,  -568,     0,     0,     0,
    -585,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,
    -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,  -585,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -585,
       0,     0,     0,  -585,  -585,     1,  -585,  -585,  -585,     0,
    -585,     0,     0,     0,     0,  -585,     0,     0,   -11,   -11,
     -13,     2,     3,   -16,   -18,   -20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     4,     0,     0,     5,     6,     7,     8,     9,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    10,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
    1272,  1273,  1274,  1275,     0,     0,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,  1684,     0,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,     0,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,     0,     0,     0,     0,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,     0,   178,   179,     0,     0,     0,     0,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1459,
     195,   901,   902,   903,   904,   905,     0,     0,   196,     0,
     910,   911,   912,     0,     0,   197,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,     0,     0,   933,   934,   935,   936,
     937,   938,   939,     0,     0,     0,     0,   942,   943,     0,
       0,     0,   944,   945,   946,   947,   948,   949,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1460,  1037,  1695,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
       0,     0,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,   920,     0,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,     0,   931,     0,     0,
       0,   932,     0,   933,   934,   935,   936,   937,   938,   939,
     940,  -628,  -628,   941,   942,   943,     0,     0,     0,   944,
     945,   946,   947,   948,   949,  1139,     0,   901,   902,   903,
     904,   905,   906,   907,   908,   909,   910,   911,   912,     0,
       0,     0,     0,     0,     0,     0,   913,   914,   915,   916,
     917,   918,   919,   920,     0,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,     0,   931,     0,     0,     0,
     932,     0,   933,   934,   935,   936,   937,   938,   939,   940,
    -630,  -630,   941,   942,   943,     0,     0,     0,   944,   945,
     946,   947,   948,   949,  1139,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,   932,
       0,   933,   934,   935,   936,   937,   938,   939,   940,  -632,
    -632,   941,   942,   943,     0,   950,  1038,   944,   945,   946,
     947,   948,   949,  1255,  1256,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
    1272,  1273,  1274,  1275,     0,     0,     0,     0,     0,     0,
    1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,
       0,  1045,  1046,  1461,  1462,     0,  1047,   545,   952,   953,
       0,     0,     0,     0,  1110,  1049,     0,   547,     0,     0,
       0,     0,  1139,     0,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,     0,     0,     0,     0,
       0,     0,   950,   913,   914,   915,   916,   917,   918,   919,
     920,     0,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,     0,   931,     0,     0,     0,   932,     0,   933,
     934,   935,   936,   937,   938,   939,   940,  -626,  -626,   941,
     942,   943,     0,     0,     0,   944,   945,   946,   947,   948,
     949,   951,     0,     0,     0,   952,   953,     0,     0,   954,
       0,     0,     0,  -628,     0,     0,     0,     0,     0,     0,
       0,   950,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,
    1274,  1275,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     951,     0,     0,     0,   952,   953,     0,     0,   954,     0,
       0,     0,  -630,     0,     0,     0,     0,     0,     0,     0,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,     0,   952,   953,     0,     0,   954,     0,     0,
       0,  -632,     0,     0,     0,     0,  1139,     0,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
       0,     0,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,   920,     0,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,     0,   931,     0,     0,
       0,   932,     0,   933,   934,   935,   936,   937,   938,   939,
     940,  -633,  -633,   941,   942,   943,     0,     0,   950,   944,
     945,   946,   947,   948,   949,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,     0,     0,
       0,   952,   953,     0,     0,   954,     0,     0,  1139,  -626,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,   932,     0,   933,   934,   935,   936,   937,
     938,   939,   940,  -627,  -627,   941,   942,   943,     0,     0,
       0,   944,   945,   946,   947,   948,   949,  1139,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,   911,
     912,     0,     0,     0,     0,     0,     0,     0,   913,   914,
     915,   916,   917,   918,   919,   920,     0,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,     0,   931,     0,
       0,     0,   932,     0,   933,   934,   935,   936,   937,   938,
     939,   940,     0,     0,   941,   942,   943,     0,     0,     0,
     944,   945,   946,   947,   948,   949,     0,     0,     0,     0,
       0,     0,  1139,     0,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,     0,     0,     0,     0,
       0,     0,   950,   913,   914,   915,   916,   917,   918,   919,
     920,     0,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,     0,   931,     0,     0,     0,   932,     0,   933,
     934,   935,   936,   937,   938,   939,   940,     0,     0,   941,
     942,   943,     0,     0,     0,   944,   945,   946,   947,   948,
     949,   951,     0,     0,     0,   952,   953,     0,     0,   954,
       0,     0,  1139,  -633,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,     0,     0,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
     920,     0,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,     0,   931,     0,     0,     0,   932,     0,   933,
     934,   935,   936,   937,   938,   939,   940,     0,     0,   941,
     942,   943,     0,     0,   950,   944,   945,   946,   947,   948,
     949,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   951,     0,     0,     0,   952,   953,     0,
       0,   954,     0,     0,     0,  -627,     0,     0,     0,     0,
       0,     0,     0,   950,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,     0,     0,     0,   952,   953,     0,     0,
     954,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,     0,     0,
       0,   952,   953,     0,     0,   954,     0,     0,  1139,  1162,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,     0,     0,     0,     0,     0,     0,   950,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,   932,     0,   933,   934,   935,   936,   937,
     938,   939,   940,     0,     0,   941,   942,   943,     0,     0,
       0,   944,   945,   946,   947,   948,   949,   951,     0,     0,
       0,   952,   953,     0,     0,   954,     0,     0,  1139,  1164,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,   932,     0,   933,   934,   935,   936,   937,
     938,   939,   940,     0,     0,   941,   942,   943,     0,     0,
       0,   944,   945,   946,   947,   948,   949,  1139,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,   911,
     912,     0,     0,     0,     0,     0,     0,     0,   913,   914,
     915,   916,   917,   918,   919,   920,     0,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,     0,   931,     0,
       0,     0,   932,     0,   933,   934,   935,   936,   937,   938,
     939,   940,     0,     0,   941,   942,   943,     0,     0,     0,
     944,   945,   946,   947,   948,   949,     0,     0,     0,     0,
       0,     0,  1139,     0,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,     0,     0,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
     920,     0,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,     0,   931,     0,     0,     0,   932,     0,   933,
     934,   935,   936,   937,   938,   939,   940,     0,     0,   941,
     942,   943,     0,     0,   950,   944,   945,   946,   947,   948,
     949,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   951,     0,     0,     0,   952,   953,     0,
       0,   954,     0,     0,  1139,  1166,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,     0,     0,
       0,     0,     0,     0,   950,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,   932,
       0,   933,   934,   935,   936,   937,   938,   939,   940,     0,
       0,   941,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,   951,     0,     0,     0,   952,   953,     0,
       0,   954,     0,     0,     0,  1172,     0,     0,     0,     0,
       0,     0,     0,   950,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,     0,     0,     0,   952,   953,     0,     0,
     954,     0,     0,     0,  1451,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   951,     0,     0,
       0,   952,   953,     0,     0,   954,     0,     0,  1139,  1570,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,   932,     0,   933,   934,   935,   936,   937,
     938,   939,   940,     0,     0,   941,   942,   943,     0,     0,
     950,   944,   945,   946,   947,   948,   949,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,     0,   952,   953,     0,     0,   954,     0,     0,
    1139,  1575,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,     0,     0,     0,     0,     0,     0,
       0,   913,   914,   915,   916,   917,   918,   919,   920,     0,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
       0,   931,     0,     0,     0,   932,     0,   933,   934,   935,
     936,   937,   938,   939,   940,     0,     0,   941,   942,   943,
       0,     0,     0,   944,   945,   946,   947,   948,   949,  1139,
       0,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,   911,   912,     0,     0,     0,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,   932,     0,   933,   934,   935,   936,
     937,   938,   939,   940,     0,     0,   941,   942,   943,     0,
       0,     0,   944,   945,   946,   947,   948,   949,     0,     0,
       0,     0,     0,     0,  1139,     0,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,     0,     0,
       0,     0,     0,     0,   950,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,   932,
       0,   933,   934,   935,   936,   937,   938,   939,   940,     0,
       0,   941,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,   951,     0,     0,     0,   952,   953,     0,
       0,   954,     0,     0,  1139,  1615,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,   932,
       0,   933,   934,   935,   936,   937,   938,   939,   940,     0,
       0,   941,   942,   943,     0,     0,   950,   944,   945,   946,
     947,   948,   949,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   951,     0,     0,     0,   952,
     953,     0,     0,   954,     0,     0,     0,  1635,     0,     0,
       0,     0,     0,     0,     0,   950,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   951,     0,     0,     0,   952,   953,
       0,     0,   954,     0,     0,     0,  1636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,     0,   952,   953,     0,     0,   954,     0,     0,
       0,  1637,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   951,
       0,     0,     0,   952,   953,     0,     0,   954,     0,     0,
    1424,  1638,   901,   902,   903,   904,   905,     0,     0,     0,
       0,   910,   911,   912,     0,     0,     0,     0,     0,     0,
       0,   913,   914,   915,   916,   917,   918,   919,   920,     0,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
       0,   931,     0,     0,     0,     0,     0,   933,   934,   935,
     936,   937,   938,   939,     0,     0,     0,     0,   942,   943,
       0,     0,     0,   944,   945,   946,   947,   948,   949,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1425,  1426,  1427,
    1428,  1429,  1430,  1434,     0,   901,   902,   903,   904,   905,
       0,     0,     0,     0,   910,   911,   912,     0,     0,     0,
       0,     0,     0,     0,   913,   914,   915,   916,   917,   918,
     919,   920,     0,   921,   922,   923,   924,   925,   926,   927,
     928,   929,   930,     0,   931,     0,     0,     0,     0,     0,
     933,   934,   935,   936,   937,   938,   939,     0,     0,     0,
       0,   942,   943,     0,     0,     0,   944,   945,   946,   947,
     948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1425,  1426,  1427,  1428,  1429,  1430,  1229,     0,   901,   902,
     903,   904,   905,     0,     0,     0,     0,   910,   911,   912,
       0,     0,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,   920,     0,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,     0,   931,     0,     0,
       0,     0,     0,   933,   934,   935,   936,   937,   938,   939,
       0,     0,     0,     0,   942,   943,     0,     0,     0,   944,
     945,   946,   947,   948,   949,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   950,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1039,  1431,     0,     0,  1040,     0,  1041,  1042,  1043,
    1044,     0,  1045,  1046,   506,   951,     0,  1047,     0,   952,
     953,     0,     0,     0,     0,  1110,  1049,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   950,
    1038,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1039,  1431,     0,     0,  1040,     0,
    1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,     0,
    1047,     0,   952,   953,     0,     0,     0,     0,  1110,  1049,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   950,  1038,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,  1040,     0,  1041,  1042,  1043,  1044,     0,  1045,  1046,
     506,   951,     0,  1047,     0,   952,   953,     0,     0,     0,
    1230,  1110,  1049,  1229,     0,   901,   902,   903,   904,   905,
       0,     0,     0,     0,   910,   911,   912,     0,     0,     0,
       0,     0,     0,     0,   913,   914,   915,   916,   917,   918,
     919,   920,     0,   921,   922,   923,   924,   925,   926,   927,
     928,   929,   930,     0,   931,     0,     0,     0,     0,     0,
     933,   934,   935,   936,   937,   938,   939,     0,     0,     0,
       0,   942,   943,     0,     0,     0,   944,   945,   946,   947,
     948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1229,     0,   901,   902,   903,   904,   905,     0,     0,     0,
       0,   910,   911,   912,     0,     0,     0,     0,     0,     0,
       0,   913,   914,   915,   916,   917,   918,   919,   920,     0,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
       0,   931,     0,     0,     0,     0,     0,   933,   934,   935,
     936,   937,   938,   939,     0,     0,     0,     0,   942,   943,
       0,     0,     0,   944,   945,   946,   947,   948,   949,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1621,     0,   901,
     902,   903,   904,   905,     0,     0,     0,     0,   910,   911,
     912,     0,     0,     0,     0,     0,     0,     0,   913,   914,
     915,   916,   917,   918,   919,   920,     0,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,     0,   931,     0,
       0,     0,     0,     0,   933,   934,   935,   936,   937,   938,
     939,     0,     0,     0,     0,   942,   943,     0,     0,     0,
     944,   945,   946,   947,   948,   949,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   950,
    1038,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1039,     0,     0,     0,  1040,     0,
    1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,     0,
    1047,     0,   952,   953,     0,     0,     0,  1278,  1110,  1049,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   950,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,
    1044,     0,  1045,  1046,   506,   951,     0,  1047,     0,   952,
     953,     0,     0,     0,  1279,  1110,  1049,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   950,  1038,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1039,     0,
    1622,     0,  1040,     0,  1041,  1042,  1043,  1044,     0,  1045,
    1046,   506,   951,     0,  1047,     0,   952,   953,     0,     0,
       0,     0,  1110,  1049,  1122,     0,   901,   902,   903,   904,
     905,     0,     0,     0,     0,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,     0,
       0,   933,   934,   935,   936,   937,   938,   939,     0,     0,
       0,     0,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1221,     0,   901,   902,   903,   904,   905,     0,     0,
       0,     0,   910,   911,   912,     0,     0,     0,     0,     0,
       0,     0,   913,   914,   915,   916,   917,   918,   919,   920,
       0,   921,   922,   923,   924,   925,   926,   927,   928,   929,
     930,     0,   931,     0,     0,     0,     0,     0,   933,   934,
     935,   936,   937,   938,   939,     0,     0,     0,     0,   942,
     943,     0,     0,     0,   944,   945,   946,   947,   948,   949,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1223,     0,
     901,   902,   903,   904,   905,     0,     0,     0,     0,   910,
     911,   912,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,     0,     0,   933,   934,   935,   936,   937,
     938,   939,     0,     0,     0,     0,   942,   943,     0,     0,
       0,   944,   945,   946,   947,   948,   949,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,  1038,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,  1040,
       0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,
       0,  1047,     0,   952,   953,     0,     0,     0,     0,  1110,
    1049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   950,  1038,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1039,     0,     0,     0,  1040,     0,  1041,  1042,
    1043,  1044,     0,  1045,  1046,   506,   951,     0,  1047,     0,
     952,   953,     0,     0,     0,     0,  1110,  1049,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   950,  1038,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,     0,
    1045,  1046,   506,   951,     0,  1047,     0,   952,   953,     0,
       0,     0,     0,  1110,  1049,  1225,     0,   901,   902,   903,
     904,   905,     0,     0,     0,     0,   910,   911,   912,     0,
       0,     0,     0,     0,     0,     0,   913,   914,   915,   916,
     917,   918,   919,   920,     0,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,     0,   931,     0,     0,     0,
       0,     0,   933,   934,   935,   936,   937,   938,   939,     0,
       0,     0,     0,   942,   943,     0,     0,     0,   944,   945,
     946,   947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1251,     0,   901,   902,   903,   904,   905,     0,
       0,     0,     0,   910,   911,   912,     0,     0,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
     920,     0,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,     0,   931,     0,     0,     0,     0,     0,   933,
     934,   935,   936,   937,   938,   939,     0,     0,     0,     0,
     942,   943,     0,     0,     0,   944,   945,   946,   947,   948,
     949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1285,
       0,   901,   902,   903,   904,   905,     0,     0,     0,     0,
     910,   911,   912,     0,     0,     0,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,     0,     0,   933,   934,   935,   936,
     937,   938,   939,     0,     0,     0,     0,   942,   943,     0,
       0,     0,   944,   945,   946,   947,   948,   949,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   950,  1038,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1039,     0,     0,     0,
    1040,     0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,
     951,     0,  1047,     0,   952,   953,     0,     0,     0,     0,
    1110,  1049,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,  1038,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,  1040,     0,  1041,
    1042,  1043,  1044,     0,  1045,  1046,   506,   951,     0,  1047,
       0,   952,   953,     0,     0,     0,     0,  1110,  1049,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,  1038,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,
       0,  1045,  1046,   506,  1286,     0,  1047,     0,   952,   953,
       0,     0,     0,     0,  1110,  1049,  1229,     0,   901,   902,
     903,   904,   905,     0,     0,     0,     0,   910,   911,   912,
       0,     0,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,   920,     0,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,     0,   931,     0,     0,
       0,     0,     0,   933,   934,   935,   936,   937,   938,   939,
       0,     0,     0,     0,   942,   943,     0,     0,     0,   944,
     945,   946,   947,   948,   949,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1421,     0,   901,   902,   903,   904,   905,
       0,     0,     0,     0,   910,   911,   912,     0,     0,     0,
       0,     0,     0,     0,   913,   914,   915,   916,   917,   918,
     919,   920,     0,   921,   922,   923,   924,   925,   926,   927,
     928,   929,   930,     0,   931,     0,     0,     0,     0,     0,
     933,   934,   935,   936,   937,   938,   939,     0,     0,     0,
       0,   942,   943,     0,     0,     0,   944,   945,   946,   947,
     948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1443,     0,   901,   902,   903,   904,   905,     0,     0,     0,
       0,   910,   911,   912,     0,     0,     0,     0,     0,     0,
       0,   913,   914,   915,   916,   917,   918,   919,   920,     0,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
       0,   931,     0,     0,     0,     0,     0,   933,   934,   935,
     936,   937,   938,   939,     0,     0,     0,     0,   942,   943,
       0,     0,     0,   944,   945,   946,   947,   948,   949,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   950,  1038,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,  1040,     0,  1041,  1042,  1043,  1044,     0,  1045,  1046,
     506,   951,     0,  1047,     0,   952,   953,     0,     0,     0,
       0,  1110,  1049,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   950,
    1038,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1039,     0,     0,     0,  1040,     0,
    1041,  1042,  1043,  1044,     0,  1045,  1046,   506,  1422,     0,
    1047,     0,   952,   953,     0,     0,     0,     0,  1110,  1049,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   950,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,
    1044,     0,  1045,  1046,   506,   951,     0,  1047,     0,   952,
     953,     0,     0,     0,     0,  1110,  1049,  1445,     0,   901,
     902,   903,   904,   905,     0,     0,     0,     0,   910,   911,
     912,     0,     0,     0,     0,     0,     0,     0,   913,   914,
     915,   916,   917,   918,   919,   920,     0,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,     0,   931,     0,
       0,     0,     0,     0,   933,   934,   935,   936,   937,   938,
     939,     0,     0,     0,     0,   942,   943,     0,     0,     0,
     944,   945,   946,   947,   948,   949,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1452,     0,   901,   902,   903,   904,
     905,     0,     0,     0,     0,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,     0,
       0,   933,   934,   935,   936,   937,   938,   939,     0,     0,
       0,     0,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1453,
    1037,  1455,     0,   901,   902,   903,   904,   905,     0,     0,
       0,     0,   910,   911,   912,     0,     0,     0,     0,     0,
       0,     0,   913,   914,   915,   916,   917,   918,   919,   920,
       0,   921,   922,   923,   924,   925,   926,   927,   928,   929,
     930,     0,   931,     0,     0,     0,     0,     0,   933,   934,
     935,   936,   937,   938,   939,     0,     0,     0,     0,   942,
     943,     0,     0,     0,   944,   945,   946,   947,   948,   949,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   950,  1038,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1039,     0,
       0,     0,  1040,     0,  1041,  1042,  1043,  1044,     0,  1045,
    1046,   506,   951,     0,  1047,     0,   952,   953,     0,     0,
       0,     0,  1110,  1049,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,  1038,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,  1040,
       0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,
       0,  1047,     0,   952,   953,     0,     0,     0,     0,  1110,
    1049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   950,  1038,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1039,     0,     0,     0,  1040,     0,  1041,  1042,
    1043,  1044,     0,  1045,  1046,   506,   951,     0,  1047,     0,
     952,   953,     0,     0,     0,     0,  1110,  1049,  1457,     0,
     901,   902,   903,   904,   905,     0,     0,     0,     0,   910,
     911,   912,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,     0,     0,   933,   934,   935,   936,   937,
     938,   939,     0,     0,     0,     0,   942,   943,     0,     0,
       0,   944,   945,   946,   947,   948,   949,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1468,     0,   901,   902,   903,
     904,   905,     0,     0,     0,     0,   910,   911,   912,     0,
       0,     0,     0,     0,     0,     0,   913,   914,   915,   916,
     917,   918,   919,   920,     0,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,     0,   931,     0,     0,     0,
       0,     0,   933,   934,   935,   936,   937,   938,   939,     0,
       0,     0,     0,   942,   943,     0,     0,     0,   944,   945,
     946,   947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1470,     0,   901,   902,   903,   904,   905,     0,
       0,     0,     0,   910,   911,   912,     0,     0,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
     920,     0,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,     0,   931,     0,     0,     0,     0,     0,   933,
     934,   935,   936,   937,   938,   939,     0,     0,     0,     0,
     942,   943,     0,     0,     0,   944,   945,   946,   947,   948,
     949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   950,  1038,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,     0,
    1045,  1046,   506,   951,     0,  1047,     0,   952,   953,     0,
       0,     0,     0,  1110,  1049,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   950,  1038,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1039,     0,     0,     0,
    1040,     0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,
     951,     0,  1047,     0,   952,   953,     0,     0,     0,     0,
    1110,  1049,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,  1038,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,  1040,     0,  1041,
    1042,  1043,  1044,     0,  1045,  1046,   506,   951,     0,  1047,
       0,   952,   953,     0,     0,     0,     0,  1110,  1049,  1472,
       0,   901,   902,   903,   904,   905,     0,     0,     0,     0,
     910,   911,   912,     0,     0,     0,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,     0,     0,   933,   934,   935,   936,
     937,   938,   939,     0,     0,     0,     0,   942,   943,     0,
       0,     0,   944,   945,   946,   947,   948,   949,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1474,     0,   901,   902,
     903,   904,   905,     0,     0,     0,     0,   910,   911,   912,
       0,     0,     0,     0,     0,     0,     0,   913,   914,   915,
     916,   917,   918,   919,   920,     0,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,     0,   931,     0,     0,
       0,     0,     0,   933,   934,   935,   936,   937,   938,   939,
       0,     0,     0,     0,   942,   943,     0,     0,     0,   944,
     945,   946,   947,   948,   949,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1479,     0,   901,   902,   903,   904,   905,
       0,     0,     0,     0,   910,   911,   912,     0,     0,     0,
       0,     0,     0,     0,   913,   914,   915,   916,   917,   918,
     919,   920,     0,   921,   922,   923,   924,   925,   926,   927,
     928,   929,   930,     0,   931,     0,     0,     0,     0,     0,
     933,   934,   935,   936,   937,   938,   939,     0,     0,     0,
       0,   942,   943,     0,     0,     0,   944,   945,   946,   947,
     948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,  1038,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,
       0,  1045,  1046,   506,   951,     0,  1047,     0,   952,   953,
       0,     0,     0,     0,  1110,  1049,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   950,  1038,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1039,     0,     0,
       0,  1040,     0,  1041,  1042,  1043,  1044,     0,  1045,  1046,
     506,   951,     0,  1047,     0,   952,   953,     0,     0,     0,
       0,  1110,  1049,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   950,
    1038,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1039,     0,     0,     0,  1040,     0,
    1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,     0,
    1047,     0,   952,   953,     0,     0,     0,     0,  1110,  1049,
    1481,     0,   901,   902,   903,   904,   905,     0,     0,     0,
       0,   910,   911,   912,     0,     0,     0,     0,     0,     0,
       0,   913,   914,   915,   916,   917,   918,   919,   920,     0,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
       0,   931,     0,     0,     0,     0,     0,   933,   934,   935,
     936,   937,   938,   939,     0,     0,     0,     0,   942,   943,
       0,     0,     0,   944,   945,   946,   947,   948,   949,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1483,     0,   901,
     902,   903,   904,   905,     0,     0,     0,     0,   910,   911,
     912,     0,     0,     0,     0,     0,     0,     0,   913,   914,
     915,   916,   917,   918,   919,   920,     0,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,     0,   931,     0,
       0,     0,     0,     0,   933,   934,   935,   936,   937,   938,
     939,     0,     0,     0,     0,   942,   943,     0,     0,     0,
     944,   945,   946,   947,   948,   949,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1485,     0,   901,   902,   903,   904,
     905,     0,     0,     0,     0,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,     0,
       0,   933,   934,   935,   936,   937,   938,   939,     0,     0,
       0,     0,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   950,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,
    1044,     0,  1045,  1046,   506,   951,     0,  1047,     0,   952,
     953,     0,     0,     0,     0,  1110,  1049,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   950,  1038,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1039,     0,
       0,     0,  1040,     0,  1041,  1042,  1043,  1044,     0,  1045,
    1046,   506,   951,     0,  1047,     0,   952,   953,     0,     0,
       0,     0,  1110,  1049,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,  1038,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,  1040,
       0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,
       0,  1047,     0,   952,   953,     0,     0,     0,     0,  1110,
    1049,  1487,     0,   901,   902,   903,   904,   905,     0,     0,
       0,     0,   910,   911,   912,     0,     0,     0,     0,     0,
       0,     0,   913,   914,   915,   916,   917,   918,   919,   920,
       0,   921,   922,   923,   924,   925,   926,   927,   928,   929,
     930,     0,   931,     0,     0,     0,     0,     0,   933,   934,
     935,   936,   937,   938,   939,     0,     0,     0,     0,   942,
     943,     0,     0,     0,   944,   945,   946,   947,   948,   949,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1489,     0,
     901,   902,   903,   904,   905,     0,     0,     0,     0,   910,
     911,   912,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,     0,     0,   933,   934,   935,   936,   937,
     938,   939,     0,     0,     0,     0,   942,   943,     0,     0,
       0,   944,   945,   946,   947,   948,   949,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1491,     0,   901,   902,   903,
     904,   905,     0,     0,     0,     0,   910,   911,   912,     0,
       0,     0,     0,     0,     0,     0,   913,   914,   915,   916,
     917,   918,   919,   920,     0,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,     0,   931,     0,     0,     0,
       0,     0,   933,   934,   935,   936,   937,   938,   939,     0,
       0,     0,     0,   942,   943,     0,     0,     0,   944,   945,
     946,   947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   950,  1038,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1039,     0,     0,     0,  1040,     0,  1041,  1042,
    1043,  1044,     0,  1045,  1046,   506,   951,     0,  1047,     0,
     952,   953,     0,     0,     0,     0,  1110,  1049,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   950,  1038,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1039,
       0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,     0,
    1045,  1046,   506,   951,     0,  1047,     0,   952,   953,     0,
       0,     0,     0,  1110,  1049,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   950,  1038,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1039,     0,     0,     0,
    1040,     0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,
     951,     0,  1047,     0,   952,   953,     0,     0,     0,     0,
    1110,  1049,  1679,     0,   901,   902,   903,   904,   905,     0,
       0,     0,     0,   910,   911,   912,     0,     0,     0,     0,
       0,     0,     0,   913,   914,   915,   916,   917,   918,   919,
     920,     0,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,     0,   931,     0,     0,     0,     0,     0,   933,
     934,   935,   936,   937,   938,   939,     0,     0,     0,     0,
     942,   943,     0,     0,     0,   944,   945,   946,   947,   948,
     949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,   911,
     912,     0,     0,     0,     0,     0,     0,     0,   913,   914,
     915,   916,   917,   918,   919,   920,     0,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,     0,   931,     0,
       0,     0,   932,     0,   933,   934,   935,   936,   937,   938,
     939,   940,     0,     0,   941,   942,   943,     0,     0,     0,
     944,   945,   946,   947,   948,   949,   901,   902,   903,   904,
     905,     0,     0,     0,     0,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,     0,
       0,   933,   934,   935,   936,   937,   938,   939,     0,     0,
       0,     0,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   950,  1038,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1039,     0,     0,     0,  1040,     0,  1041,
    1042,  1043,  1044,     0,  1045,  1046,   506,   951,     0,  1047,
       0,   952,   953,     0,     0,     0,     0,  1110,  1049,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   950,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,
    1274,  1275,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,     0,     0,     0,   952,   953,     0,     0,
     954,     0,     0,  1322,     0,     0,     0,     0,     0,     0,
     950,  1038,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,  1040,
       0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,
       0,  1047,     0,   952,   953,     0,     0,     0,     0,  1048,
    1049,   901,   902,   903,   904,   905,     0,     0,     0,     0,
     910,   911,   912,     0,     0,     0,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,     0,     0,   933,   934,   935,   936,
     937,   938,   939,     0,     0,     0,     0,   942,   943,     0,
       0,     0,   944,   945,   946,   947,   948,   949,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,   901,   902,   903,   904,
     905,     0,     0,     0,     0,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,     0,
       0,   933,   934,   935,   936,   937,   938,   939,     0,     0,
       0,     0,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,   901,   902,   903,   904,   905,     0,     0,     0,     0,
     910,   911,   912,     0,     0,     0,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,     0,     0,   933,   934,   935,   936,
     937,   938,   939,     0,     0,     0,     0,   942,   943,     0,
       0,     0,   944,   945,   946,   947,   948,   949,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,  1038,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,
       0,  1045,  1046,   506,   951,     0,  1047,     0,   952,   953,
       0,     0,     0,     0,  1069,  1049,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     950,  1038,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,  1040,
       0,  1041,  1042,  1043,  1044,     0,  1045,  1046,   506,   951,
       0,  1047,     0,   952,   953,     0,     0,     0,     0,  1071,
    1049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,  1038,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1039,     0,     0,     0,  1040,     0,  1041,  1042,  1043,  1044,
       0,  1045,  1046,   506,   951,     0,  1047,     0,   952,   953,
       0,     0,     0,     0,  1110,  1049,   901,   902,   903,   904,
     905,     0,     0,     0,     0,   910,   911,   912,     0,     0,
       0,     0,     0,     0,     0,   913,   914,   915,   916,   917,
     918,   919,   920,     0,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,     0,   931,     0,     0,     0,     0,
       0,   933,   934,   935,   936,   937,   938,   939,     0,     0,
       0,     0,   942,   943,     0,     0,     0,   944,   945,   946,
     947,   948,   949,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,   911,   912,     0,     0,     0,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,   932,     0,   933,   934,   935,   936,
     937,   938,   939,   940,     0,     0,   941,   942,   943,     0,
       0,     0,   944,   945,   946,   947,   948,   949,  1237,     0,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,   916,   917,   918,   919,   920,     0,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,     0,   931,
       0,     0,     0,   932,     0,   933,   934,   935,   936,   937,
     938,   939,   940,     0,     0,   941,   942,   943,     0,     0,
       0,   944,   945,   946,   947,   948,   949,     0,     0,     0,
       0,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,   911,   912,     0,     0,     0,     0,     0,     0,     0,
     913,   914,   915,   916,   917,   918,   919,   920,     0,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,     0,
     931,     0,     0,     0,   932,     0,   933,   934,   935,   936,
     937,   938,   939,   940,     0,     0,   941,   942,   943,     0,
     950,  1038,   944,   945,   946,   947,   948,   949,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,  1040,
       0,  1041,  1042,  1043,  1044,     0,  1045,  1046,  1628,   951,
       0,  1047,     0,   952,   953,     0,     0,     0,     0,  1110,
    1049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   951,     0,     0,     0,   952,   953,
       0,     0,   954,     0,     0,  1322,     0,     0,     0,     0,
       0,     0,     0,     0,   950,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   951,     0,     0,     0,   952,   953,     0,
       0,   954,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   950,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   951,     0,     0,     0,   952,   953,
       0,     0,   954
};

static const yytype_int16 yycheck[] =
{
     222,   191,   221,   225,  1124,   409,     1,  1032,  1176,  1034,
     864,  1036,     1,   867,     1,     1,   870,   861,     1,     1,
     864,     1,     1,   867,   878,     1,   870,     1,  1053,   251,
       1,   253,     1,   255,   878,   257,  1011,     1,  1013,   240,
    1015,     1,  1017,   861,  1019,     1,   864,     1,   302,   867,
       1,     1,   870,     1,   335,   336,   322,   338,  1048,   110,
     878,     1,     1,     1,    57,   322,     1,     1,     1,   335,
     332,   861,     1,     1,   864,   109,   110,   867,   335,  1069,
     870,  1071,     1,     1,     1,    56,    57,   349,   878,     1,
     336,     1,   338,   350,   316,     1,     1,     1,     1,   302,
       1,    61,     1,   325,   326,   327,   328,   329,   330,   331,
     332,     1,   956,     1,   323,     1,     1,     1,     1,     1,
    1110,   302,     1,   302,   322,   322,   335,     1,     1,   973,
     322,   975,  1051,   977,   332,   332,  1055,   981,   956,   361,
     362,   363,   546,   335,    61,     1,   338,     1,     1,    88,
      89,    90,    91,     1,   343,   973,   345,   975,     1,   977,
       1,   335,     1,   981,   338,   302,   956,     1,     1,     1,
     271,   272,   273,   274,     1,     1,    88,    89,    90,    91,
       1,     1,    61,   973,     1,   975,     1,   977,    61,     1,
       1,   981,     1,   956,     1,  1049,     1,   335,   336,   859,
     338,     1,   302,   863,  1048,  1049,   866,   302,   322,   869,
     973,   302,   975,    61,   977,     1,     1,     1,   981,   441,
       1,   335,   444,   445,   338,  1069,     1,  1071,     1,     1,
    1048,  1049,    88,    89,    90,    91,   302,     1,     1,   310,
     311,   302,     1,     1,   315,   316,   302,   335,   336,     1,
     338,  1069,     1,  1071,   302,     1,     1,     1,  1048,  1049,
       1,     1,   302,     1,     1,     1,  1110,  1111,     1,     1,
     302,     1,     1,   302,  1249,     1,     1,     1,     1,  1069,
    1124,  1071,     1,     1,     1,     1,     1,     1,   890,   891,
       1,     1,  1110,  1111,     1,     1,     1,     1,     1,  1059,
       1,   352,   335,   336,     1,   338,  1124,     1,   227,   228,
     229,   230,   343,     1,   345,  1159,   302,   302,   302,  1173,
    1110,  1111,     1,     1,     1,   302,  1180,     1,     1,  1173,
       1,     1,     1,   343,  1124,   345,  1180,     1,     1,     1,
     335,  1159,   335,   336,   339,     1,     1,     1,  1111,   336,
     551,   338,   338,     1,   349,  1173,     1,   861,   347,   339,
     864,  1124,  1180,   867,   347,   347,   870,  1535,   347,   349,
     349,   347,   346,   349,   878,   335,   336,   348,   338,   339,
     349,   345,   346,  1173,   323,   345,   336,   335,   338,   349,
    1180,   347,   346,   349,  1238,   346,   335,   336,   337,   338,
     339,   335,   336,   337,   338,   339,   346,   346,   346,  1529,
     349,   323,   347,   346,   349,   349,   344,   346,   335,   336,
    1238,   338,   339,   335,   336,   337,   338,   339,  1453,   347,
     335,   349,   349,   338,   346,  1460,   346,   349,   861,   338,
     346,   864,   346,   346,   867,   346,   336,   870,  1238,   302,
     336,   335,   956,   336,   338,   878,   335,   336,   346,   338,
     339,   346,   335,   336,   346,   338,   339,   323,  1322,   973,
     349,   975,   346,   977,     1,  1238,   349,   981,  1322,   335,
     336,   337,   338,   339,   888,   338,     1,   335,   336,     1,
     338,   339,   346,   349,   335,   336,   335,   336,   337,   338,
     339,   349,   287,   346,  1322,  1359,  1360,  1361,  1362,  1677,
     349,   302,   346,   346,   346,  1359,  1360,  1361,  1362,   346,
     346,   338,  1366,    14,    15,   346,   346,     1,   302,  1373,
     335,   346,  1322,   956,   346,   346,   322,   346,   322,   346,
     345,  1359,  1360,  1361,  1362,  1049,   346,     1,  1366,   335,
     973,   335,   975,   338,   977,  1373,   341,   338,   981,   345,
     302,   336,     1,   338,   336,   338,   338,   302,    62,  1359,
    1360,  1361,  1362,   336,   338,   338,  1366,   336,   336,   338,
     338,   985,   861,  1373,   336,   864,   338,   336,   867,   338,
     336,   870,   338,   338,   338,  1355,     1,   338,   338,   878,
     338,   338,   338,  1366,   322,   338,   338,  1111,   338,   338,
    1373,     1,   338,   338,   338,   338,    62,   335,     1,   338,
    1124,   338,   338,   338,   338,  1048,  1049,   338,   338,     1,
       1,   338,   338,   338,   338,   338,  1611,   338,   335,   336,
     337,   335,   336,   337,   322,   322,  1069,   335,  1071,   322,
       1,   322,   322,   322,   302,  1159,   335,   335,   335,   322,
     322,   335,   335,     1,   335,   335,   335,   857,   322,  1173,
       1,   335,   335,   335,     1,     1,  1180,   956,   323,   335,
     335,   335,     1,     1,  1528,  1529,   302,  1110,  1111,     1,
     335,     1,     1,     1,   973,     1,   975,     1,   977,     1,
       1,  1124,   981,     1,     1,     1,     1,     1,     1,  1113,
    1528,  1529,     1,  1117,     1,     1,     1,     1,     1,  1563,
    1564,  1565,  1566,     1,     1,    62,    62,     1,   302,     1,
       1,     1,     1,     1,  1238,     1,     1,     1,  1528,  1529,
       1,     1,     1,     1,     1,  1563,  1564,  1565,  1566,    62,
    1173,     1,     1,     1,     1,     1,     1,  1180,     1,     1,
     302,     1,     1,     1,     1,  1528,  1529,     1,     1,     1,
    1049,  1625,     1,  1563,  1564,  1565,  1566,     1,     1,     1,
       1,  1625,     1,     1,     1,     1,     1,   323,   324,   325,
       1,     1,     1,     1,     1,   322,     1,     1,     1,     1,
    1563,  1564,  1565,  1566,     1,     1,     1,  1625,   335,     1,
     322,     1,     1,   302,     1,  1238,     1,     1,  1322,     1,
     335,     1,     1,   335,  1678,     1,     1,  1681,     1,     1,
     302,   302,  1111,     1,  1678,  1625,     1,  1681,  1682,  1693,
    1694,   335,   343,     1,   345,  1124,   302,   302,  1692,  1693,
    1694,     1,  1696,  1697,  1698,  1359,  1360,  1361,  1362,     1,
    1678,   335,  1366,  1681,  1682,     1,     1,     1,   322,  1373,
       1,     1,     1,  1095,  1692,  1693,  1694,   302,  1696,  1697,
    1698,   335,     1,   322,   302,     1,     1,   302,  1678,   335,
    1109,  1681,  1682,   343,  1173,   345,   335,     1,  1117,  1322,
     302,  1180,  1692,  1693,  1694,   302,  1696,  1697,  1698,     1,
     302,    56,    57,   343,   302,   345,     1,   322,   302,  1682,
       1,     1,   302,   302,     1,     1,     1,     1,     1,  1692,
     335,     1,   322,  1696,  1697,  1698,  1359,  1360,  1361,  1362,
    1130,     1,  1132,  1366,  1134,   335,    88,    89,    90,    91,
    1373,   323,   335,     1,   302,     1,     1,  1179,   322,  1238,
       1,     1,     1,   335,   335,     1,     1,     1,   332,    88,
      89,    90,    91,   322,   302,     1,     1,     1,     1,   343,
     343,   345,   345,   332,   335,   302,   906,   907,   908,   335,
     336,   337,   338,   339,   343,   302,   345,   335,   335,   335,
     310,   311,   312,   349,   335,   315,   316,   332,   335,   335,
     302,   343,   932,   345,   302,     0,   335,   335,    16,    20,
     940,   941,   335,   335,  1528,  1529,   335,   335,   302,   335,
      19,   335,   347,   335,   335,   302,   335,   335,   335,   335,
     335,   335,   335,  1322,   335,    21,   335,   302,   335,   335,
     335,   335,   335,   343,   302,   345,   335,   335,   335,  1563,
    1564,  1565,  1566,   335,   335,   335,   335,   335,   343,   335,
     335,   335,   302,   302,   335,   335,   335,   335,   335,   335,
    1359,  1360,  1361,  1362,   335,   335,   335,  1366,   335,   335,
     335,   302,   335,   335,  1373,   335,   335,   335,   335,   302,
     335,   335,   335,   335,   302,  1528,  1529,   302,   302,   302,
     302,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,  1625,  1042,  1043,  1044,   335,   335,   335,   335,   335,
     335,   335,  1536,   335,   302,   302,   302,   302,   335,   335,
    1563,  1564,  1565,  1566,   302,   335,   335,  1067,   335,   302,
     335,   335,   302,   335,   302,   335,   335,   335,  1078,   335,
     335,   302,   335,   335,   302,   302,   302,   302,   302,   343,
     302,   345,   302,   302,  1678,   302,   302,  1681,  1682,   310,
     311,   323,   302,   335,   315,   316,   302,   338,  1692,  1693,
    1694,   302,  1696,  1697,  1698,   310,   311,   312,   352,   302,
     315,   316,  1625,   348,   323,   349,   310,   311,   302,   302,
     335,   315,   316,   317,   318,   319,   320,   302,   310,   311,
     312,   302,   302,   315,   316,   302,   302,   302,   302,   302,
     302,   343,   302,   345,   302,   302,  1156,    88,    89,    90,
      91,   343,   302,   345,     1,  1467,   343,   302,   345,  1528,
    1529,   335,   302,   302,   302,  1678,   302,   302,  1681,  1682,
     343,   302,   302,   302,   302,   302,   302,   302,   302,  1692,
    1693,  1694,   302,  1696,  1697,  1698,   302,   302,   302,   302,
     322,   343,   302,   345,  1563,  1564,  1565,  1566,   302,   322,
     332,   343,   343,   345,   345,  1215,  1216,  1217,   302,   332,
    1013,   343,  1015,   345,  1017,   302,  1019,  1227,  1228,   302,
     343,   343,   345,   345,    71,    72,    73,    74,   302,    76,
    1240,    78,   322,    80,   302,   302,  1246,  1247,   302,  1249,
     302,   302,   332,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     335,   302,   302,   343,   302,   345,  1625,   302,   302,   302,
     302,  1271,  1272,  1273,  1274,  1275,  1276,  1277,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   302,   302,  1559,
     302,   335,  1562,   335,   336,   337,   338,   339,   321,   322,
     323,   324,   325,  1605,   346,   302,   302,   349,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   302,   302,  1678,
     302,   302,  1681,  1682,   302,   336,   302,   302,   302,   302,
     302,   302,   302,  1692,  1693,  1694,   302,  1696,  1697,  1698,
     302,   302,   302,   302,   302,   302,   302,   302,   302,  1349,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   323,   302,   347,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   335,   336,   337,   338,   339,   302,
     302,   302,   302,   302,   302,   346,   302,   302,   349,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   302,   302,   339,   302,   302,   302,   335,   347,
     347,   347,   335,   335,   335,   335,  1249,   335,   335,   335,
     335,   345,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   335,   345,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   335,   335,
     335,   335,   335,   335,   335,   335,   335,     0,     1,  1539,
     335,   335,   335,   335,   335,  1545,   335,   345,   335,   335,
     347,    14,    15,    16,    17,    18,    19,    20,    21,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,    38,   350,   332,    41,    42,
      43,    44,    45,   352,   352,   343,   335,   302,   342,   350,
     335,   343,   345,   350,    57,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   338,   338,
     350,   346,  1622,   346,   346,   346,   302,   332,   346,   346,
    1630,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   346,   346,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     346,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   346,   346,   344,   344,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   350,   269,   270,   350,   350,
     350,   347,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   332,   352,   343,   347,   346,   338,
     346,   345,   345,   345,   345,   345,   299,   300,   301,   345,
     345,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   345,   345,   332,   346,   268,   268,
     347,   349,   347,   336,   347,   347,   335,   338,   335,   302,
     345,   344,   336,   345,   302,   345,   302,     1,   351,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,   345,   345,   345,   345,   302,   345,   345,    22,    23,
      24,    25,    26,    27,    28,    29,   348,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,   349,    42,   343,
     345,    47,    46,   345,    48,    49,    50,    51,    52,    53,
      54,    55,   343,   345,    58,    59,    60,   345,   352,   345,
      64,    65,    66,    67,    68,    69,     1,   345,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
     345,   345,   345,   345,   345,   345,   345,    22,    23,    24,
      25,    26,    27,    28,    29,   345,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,   345,    42,   345,   345,
     345,    46,   345,    48,    49,    50,    51,    52,    53,    54,
      55,   345,   345,    58,    59,    60,   345,   345,   345,    64,
      65,    66,    67,    68,    69,     1,   345,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,   345,
     345,   345,   345,   345,   345,   345,    22,    23,    24,    25,
      26,    27,    28,    29,   345,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,   345,    42,   345,   352,   345,
      46,   345,    48,    49,    50,    51,    52,    53,    54,    55,
     343,   345,    58,    59,    60,   345,   345,   345,    64,    65,
      66,    67,    68,    69,     1,   345,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,   345,   345,
     345,   336,   350,   343,   338,    22,    23,    24,    25,    26,
      27,    28,    29,   338,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,   302,    42,   332,   110,   345,    46,
     345,    48,    49,    50,    51,    52,    53,    54,    55,   335,
     335,    58,    59,    60,   335,   335,   335,    64,    65,    66,
      67,    68,    69,   335,   335,   335,   335,   349,   335,   335,
     335,   335,   335,   287,   335,   332,   324,   352,   352,   338,
     338,   335,   338,   345,   199,   345,  1217,   855,   886,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   348,   345,   345,   345,   345,   345,   332,   345,
     345,   345,   336,   345,   345,   345,   340,   341,   345,   343,
     344,   345,   346,   347,   345,   345,   345,   345,   352,   345,
     345,   345,   287,   345,   345,   345,   345,   345,   345,   352,
     345,   345,   345,   345,   350,   345,   345,   985,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   352,   350,   350,   857,   368,   352,   352,   369,  1219,
     547,   336,  1171,  1219,  1543,   340,   341,  1350,   343,   344,
     345,   346,   347,    -1,    -1,    -1,  1622,   352,    -1,  1630,
      -1,   287,  1606,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     336,    -1,    -1,    -1,   340,   341,    -1,   343,   344,   345,
      -1,   347,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,
     287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,
      -1,    -1,    -1,   340,   341,     1,   343,   344,   345,    -1,
     347,    -1,    -1,    -1,    -1,   352,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    41,    42,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   345,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,    -1,    -1,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,    -1,    -1,    -1,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,   300,   301,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
     336,     3,     4,     5,     6,     7,    -1,    -1,   344,    -1,
      12,    13,    14,    -1,    -1,   351,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,   287,   288,    64,    65,    66,
      67,    68,    69,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,    -1,   338,   339,   340,   341,
      -1,    -1,    -1,    -1,   346,   347,    -1,   349,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   287,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,   336,    -1,    -1,    -1,   340,   341,    -1,    -1,   344,
      -1,    -1,    -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     336,    -1,    -1,    -1,   340,   341,    -1,    -1,   344,    -1,
      -1,    -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,
      -1,    -1,    -1,   340,   341,    -1,    -1,   344,    -1,    -1,
      -1,   348,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,   287,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,
      -1,   340,   341,    -1,    -1,   344,    -1,    -1,     1,   348,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   287,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,   336,    -1,    -1,    -1,   340,   341,    -1,    -1,   344,
      -1,    -1,     1,   348,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,   287,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   336,    -1,    -1,    -1,   340,   341,    -1,
      -1,   344,    -1,    -1,    -1,   348,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   336,    -1,    -1,    -1,   340,   341,    -1,    -1,
     344,    -1,    -1,    -1,   348,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,
      -1,   340,   341,    -1,    -1,   344,    -1,    -1,     1,   348,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   287,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,   336,    -1,    -1,
      -1,   340,   341,    -1,    -1,   344,    -1,    -1,     1,   348,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,   287,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   336,    -1,    -1,    -1,   340,   341,    -1,
      -1,   344,    -1,    -1,     1,   348,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   287,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,   336,    -1,    -1,    -1,   340,   341,    -1,
      -1,   344,    -1,    -1,    -1,   348,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   336,    -1,    -1,    -1,   340,   341,    -1,    -1,
     344,    -1,    -1,    -1,   348,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,
      -1,   340,   341,    -1,    -1,   344,    -1,    -1,     1,   348,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
     287,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,
      -1,    -1,    -1,   340,   341,    -1,    -1,   344,    -1,    -1,
       1,   348,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   287,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,   336,    -1,    -1,    -1,   340,   341,    -1,
      -1,   344,    -1,    -1,     1,   348,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,   287,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,    -1,   340,
     341,    -1,    -1,   344,    -1,    -1,    -1,   348,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   336,    -1,    -1,    -1,   340,   341,
      -1,    -1,   344,    -1,    -1,    -1,   348,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,
      -1,    -1,    -1,   340,   341,    -1,    -1,   344,    -1,    -1,
      -1,   348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,
      -1,    -1,    -1,   340,   341,    -1,    -1,   344,    -1,    -1,
       1,   348,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   322,   323,    -1,    -1,   326,    -1,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,    -1,   338,    -1,   340,
     341,    -1,    -1,    -1,    -1,   346,   347,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   322,   323,    -1,    -1,   326,    -1,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,    -1,
     338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,   347,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   287,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
      -1,   326,    -1,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,    -1,   338,    -1,   340,   341,    -1,    -1,    -1,
     345,   346,   347,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,    -1,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,    -1,
     338,    -1,   340,   341,    -1,    -1,    -1,   345,   346,   347,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,    -1,   338,    -1,   340,
     341,    -1,    -1,    -1,   345,   346,   347,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,
     324,    -1,   326,    -1,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,    -1,   338,    -1,   340,   341,    -1,    -1,
      -1,    -1,   346,   347,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
      -1,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
      -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,
     347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   322,    -1,    -1,    -1,   326,    -1,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,    -1,   338,    -1,
     340,   341,    -1,    -1,    -1,    -1,   346,   347,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,
      -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,    -1,   338,    -1,   340,   341,    -1,
      -1,    -1,    -1,   346,   347,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,
     326,    -1,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,    -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,
     346,   347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   322,    -1,    -1,    -1,   326,    -1,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,    -1,   338,
      -1,   340,   341,    -1,    -1,    -1,    -1,   346,   347,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,    -1,   338,    -1,   340,   341,
      -1,    -1,    -1,    -1,   346,   347,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   287,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
      -1,   326,    -1,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,    -1,   338,    -1,   340,   341,    -1,    -1,    -1,
      -1,   346,   347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,    -1,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,    -1,
     338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,   347,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,    -1,   338,    -1,   340,
     341,    -1,    -1,    -1,    -1,   346,   347,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,
      -1,    -1,   326,    -1,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,    -1,   338,    -1,   340,   341,    -1,    -1,
      -1,    -1,   346,   347,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
      -1,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
      -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,
     347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   322,    -1,    -1,    -1,   326,    -1,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,    -1,   338,    -1,
     340,   341,    -1,    -1,    -1,    -1,   346,   347,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,
      -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,    -1,   338,    -1,   340,   341,    -1,
      -1,    -1,    -1,   346,   347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,
     326,    -1,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,    -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,
     346,   347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   322,    -1,    -1,    -1,   326,    -1,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,    -1,   338,
      -1,   340,   341,    -1,    -1,    -1,    -1,   346,   347,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,    -1,   338,    -1,   340,   341,
      -1,    -1,    -1,    -1,   346,   347,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   287,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
      -1,   326,    -1,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,    -1,   338,    -1,   340,   341,    -1,    -1,    -1,
      -1,   346,   347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,    -1,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,    -1,
     338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,   347,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,    -1,   338,    -1,   340,
     341,    -1,    -1,    -1,    -1,   346,   347,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,
      -1,    -1,   326,    -1,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,    -1,   338,    -1,   340,   341,    -1,    -1,
      -1,    -1,   346,   347,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
      -1,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
      -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,
     347,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   322,    -1,    -1,    -1,   326,    -1,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,    -1,   338,    -1,
     340,   341,    -1,    -1,    -1,    -1,   346,   347,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,
      -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,    -1,   338,    -1,   340,   341,    -1,
      -1,    -1,    -1,   346,   347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,
     326,    -1,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,    -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,
     346,   347,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   322,    -1,    -1,    -1,   326,    -1,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,    -1,   338,
      -1,   340,   341,    -1,    -1,    -1,    -1,   346,   347,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   336,    -1,    -1,    -1,   340,   341,    -1,    -1,
     344,    -1,    -1,   347,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
      -1,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
      -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,
     347,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,    -1,   338,    -1,   340,   341,
      -1,    -1,    -1,    -1,   346,   347,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     287,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
      -1,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
      -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,
     347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,    -1,   326,    -1,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,    -1,   338,    -1,   340,   341,
      -1,    -1,    -1,    -1,   346,   347,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
     287,   288,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
      -1,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
      -1,   338,    -1,   340,   341,    -1,    -1,    -1,    -1,   346,
     347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   336,    -1,    -1,    -1,   340,   341,
      -1,    -1,   344,    -1,    -1,   347,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   336,    -1,    -1,    -1,   340,   341,    -1,
      -1,   344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   287,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   336,    -1,    -1,    -1,   340,   341,
      -1,    -1,   344
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    41,    42,    43,    44,    45,
      57,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   269,   270,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   299,   300,   301,   336,   344,   351,   354,   355,
     356,   357,   358,   359,   360,   361,   372,   376,   379,   380,
     382,   383,   393,   394,   403,   302,     1,   349,     1,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,     1,   302,     1,   302,     1,   302,
       1,   302,     1,   302,     1,   302,     1,   302,     1,   302,
       1,   302,     1,   302,     1,   302,     1,   302,     1,   302,
       1,   302,     1,   302,     1,   302,     1,   302,     1,   302,
       1,   302,     1,   302,     1,   302,     1,   302,     1,   302,
       1,   302,     1,   302,     1,   302,     1,   302,     1,   302,
       1,   302,     1,   302,     1,   302,     1,   302,     1,   302,
       1,   302,     1,   302,     1,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,     1,   338,
       1,   302,   338,     1,   346,     1,   302,   338,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,     1,   302,     1,   302,     1,   302,     1,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,     1,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     332,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,     1,   336,   338,   373,   374,   375,     1,   375,   377,
     378,     1,   338,     1,   338,     1,   338,     0,     1,   356,
      14,    15,   389,   390,    16,   391,   392,    19,   397,   398,
      20,   399,   400,    21,   401,   402,   332,   349,   347,   335,
     336,   338,   388,     1,   335,     1,   335,     1,    88,    89,
      90,    91,   323,   365,     1,   322,   335,   371,     1,   335,
       1,   335,     1,   371,     1,   335,     1,   335,     1,   335,
       1,   335,     1,   336,     1,   338,     1,   335,     1,   338,
       1,   335,     1,   338,     1,   338,     1,   338,     1,   338,
       1,   335,   336,   337,   338,   339,   346,   349,   362,   364,
     365,   369,   370,   384,   385,   386,   387,   417,   418,     1,
     370,     1,   335,     1,   335,     1,   335,   335,   335,   335,
     371,   371,   371,   371,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,     1,   371,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   371,     1,   371,     1,   371,     1,   371,     1,
     371,     1,   371,     1,   371,     1,   371,     1,   335,     1,
     335,     1,   338,     1,   338,     1,   335,     1,   338,   338,
       1,   338,     1,   335,     1,   335,     1,   336,   338,     1,
     336,   338,     1,   336,   338,     1,   336,   338,     1,   336,
     338,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   371,     1,   371,     1,   371,     1,
     336,   338,     1,   335,     1,   335,     1,   335,     1,   335,
     385,     1,   387,     1,   335,     1,   335,   335,   335,   335,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   227,   228,
     229,   230,     1,   335,     1,   335,     1,   335,     1,   335,
       1,   338,     1,   338,     1,   338,     1,   335,     1,   335,
       1,   335,     1,   362,     1,   335,     1,   335,     1,   335,
       1,   335,     1,   335,     1,   335,     1,   335,     1,   335,
       1,   335,     1,   335,     1,   335,     1,   335,     1,   335,
       1,   335,     1,   335,     1,   336,   338,     1,   335,   336,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   338,     1,   335,     1,
     335,     1,   335,   271,   272,   273,   274,     1,   371,   335,
     335,     1,   371,     1,   371,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,   343,   352,   343,     1,   349,
       1,   347,     1,   349,   347,     1,   349,   347,     1,   349,
     347,     1,   349,    57,   335,   336,   381,   335,   395,   350,
     335,   332,   362,   363,   386,   352,   352,   370,   109,   110,
     322,   332,   343,   302,   302,   302,   302,   373,   335,   377,
     388,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    22,    23,    24,    25,    26,    27,    28,
      29,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    42,    46,    48,    49,    50,    51,    52,    53,    54,
      55,    58,    59,    60,    64,    65,    66,    67,    68,    69,
     287,   336,   340,   341,   344,   419,   421,   422,   423,   427,
     428,   436,   437,   439,   440,   443,   444,   446,   450,   451,
     452,   456,   388,   421,   388,   421,   388,   421,   342,   302,
     350,   421,     1,   396,   335,   343,   345,   350,     1,   323,
     335,   367,   364,   362,   338,     1,   335,   417,     1,   417,
     338,     1,   338,     1,   338,     1,   338,     1,   338,   350,
       1,   346,     1,   346,     1,   346,     1,   346,     1,   346,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,   288,   322,
     326,   328,   329,   330,   331,   333,   334,   338,   346,   347,
     371,   409,   410,   411,   412,   413,   414,   419,   431,   436,
     437,   438,   439,   441,   443,   444,   447,   448,   449,   346,
     449,   346,   449,     1,   346,     1,   346,     1,   346,   346,
       1,   346,     1,   346,     1,   346,     1,   346,     1,   346,
       1,   346,     1,   346,     1,   346,   346,     1,   346,     1,
     346,     1,   346,     1,   346,   346,   346,   346,   346,   346,
     346,   449,     1,   346,     1,   346,     1,   346,   346,   346,
     346,   346,     1,   449,   449,     1,   346,     1,   346,     1,
     346,     1,   346,     1,   346,     1,   453,     1,   344,     1,
     348,   422,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   336,   433,   434,   435,   302,   445,   344,     1,   346,
     344,   350,   348,   350,   348,   350,   348,   350,     1,   335,
     338,   332,   348,   347,   332,   363,   352,   110,   352,   343,
     347,     1,    61,   336,   338,   345,   384,   416,     1,    61,
     338,   384,   416,     1,    61,   338,   384,   416,     1,    61,
     338,   384,   416,     1,    61,   338,   384,   416,     1,   310,
     311,   312,   315,   316,   404,   406,   404,   404,     1,   404,
     432,     1,   449,     1,   449,     1,   449,   346,   346,     1,
     345,   437,   439,   443,   444,   449,   450,     1,   421,     1,
     406,     1,   317,   318,   319,   320,   404,   405,     1,   406,
     435,     1,   449,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   407,   408,   345,   345,
       1,   335,   338,     1,   338,     1,   336,   449,   338,     1,
     338,     1,   338,     1,   338,     1,   338,     1,   335,     1,
     335,   345,     1,   345,   371,   345,     1,   338,     1,   338,
       1,   338,     1,   338,   345,   345,   345,     1,   335,   345,
       1,   365,   347,   420,   422,     1,   362,     1,   335,     1,
     362,   365,   368,   345,   345,   345,   345,   347,   420,     1,
     338,     1,   338,   335,   375,   335,   375,   335,   375,   346,
     332,   349,   449,     1,   338,   436,   437,   442,   444,   347,
     347,   347,   347,   268,   268,   381,   421,   335,   367,   338,
     335,   338,   371,   421,   345,   343,   345,   343,   345,   343,
     345,   322,   332,   343,   345,   345,   343,   345,   343,   345,
     343,   345,   343,   345,   345,   343,   345,   343,   345,   343,
     345,   343,   345,   345,   343,   345,   343,   345,   343,   345,
     343,   345,   345,   343,   345,   343,   345,   343,   345,   343,
     345,     1,   336,   449,     1,    88,    89,    90,    91,    92,
      93,   323,   366,   449,     1,   366,   449,     1,   409,   413,
     336,   429,   430,     1,   449,     1,   449,   345,   345,   345,
     348,   348,     1,    86,   449,     1,   449,     1,   449,     1,
      86,   335,   336,   384,   415,   416,   449,   349,     1,   449,
       1,   449,     1,   449,     1,   449,   449,   449,   449,     1,
     449,     1,   449,     1,   449,     1,   449,     1,   449,     1,
     449,     1,   449,   345,   343,   345,   345,   343,   345,   345,
     345,   345,   345,   345,   345,   345,   345,   345,   345,   345,
     345,   345,   345,   345,   345,   345,   345,   345,   345,   345,
     345,   345,   345,   345,   345,   345,   345,   345,   421,    47,
     345,   345,   345,   345,   345,   352,   352,   345,     1,    56,
      57,   348,   425,   426,   345,   343,   345,   345,   345,   345,
     345,   345,   345,   345,   449,   454,   455,   434,   350,   343,
     345,   435,   343,   421,   421,   421,   421,   338,   338,   302,
     348,   332,   110,   345,   345,   348,    62,   335,   335,   335,
       1,   336,     1,   336,   335,    62,   335,   335,   335,   335,
      62,   335,   335,   335,   335,    62,   335,   335,   335,   335,
      62,   335,   335,   335,   335,   349,   332,   345,   345,   345,
     345,   324,   371,   338,   338,   348,   420,     1,   367,   362,
     348,     1,   324,   424,   449,   352,   348,   425,   335,   449,
     343,   345,   375,     1,   375,   348,   348,   348,   348,   335,
     338,   335,   338,   345,   345,   345,   345,   345,   345,   345,
     345,   345,   345,   345,   345,   345,   345,   345,   345,   345,
     345,   345,   345,   345,   345,   345,   345,   345,   338,   371,
     429,     1,   335,   384,   350,   345,   345,   352,   352,     1,
     424,   352,   421,   345,   345,   455,   345,   345,   345,   350,
     350,   367,   421,   352,   352,     1,   421,   421,   421
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   353,   354,   355,   355,   355,   356,   356,   356,   356,
     356,   357,   356,   358,   356,   356,   359,   356,   360,   356,
     361,   356,   356,   356,   362,   362,   362,   363,   363,   364,
     364,   365,   365,   365,   365,   365,   366,   366,   366,   366,
     366,   366,   366,   367,   367,   368,   368,   368,   368,   368,
     369,   369,   369,   369,   369,   370,   370,   371,   371,   372,
     372,   373,   373,   374,   374,   375,   375,   376,   376,   377,
     377,   378,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   380,   380,   381,   381,
     381,   382,   382,   382,   382,   382,   382,   382,   383,   383,
     383,   383,   383,   383,   383,   383,   383,   383,   383,   383,
     383,   384,   384,   385,   386,   387,   387,   388,   388,   388,
     389,   389,   390,   390,   390,   390,   391,   392,   392,   392,
     393,   393,   395,   394,   394,   394,   396,   394,   394,   397,
     398,   398,   398,   399,   400,   400,   400,   401,   402,   402,
     403,   403,   403,   403,   403,   403,   404,   404,   404,   404,
     405,   405,   405,   405,   406,   406,   407,   407,   407,   407,
     407,   407,   407,   408,   408,   408,   408,   409,   409,   409,
     410,   410,   410,   411,   411,   411,   411,   411,   412,   412,
     413,   413,   413,   414,   414,   414,   414,   414,   414,   414,
     414,   414,   414,   414,   414,   414,   414,   414,   414,   414,
     414,   414,   414,   414,   414,   414,   414,   414,   414,   414,
     414,   414,   415,   415,   415,   415,   416,   416,   416,   416,
     416,   417,   417,   417,   418,   418,   418,   418,   418,   419,
     420,   420,   421,   421,   421,   422,   422,   422,   422,   422,
     422,   422,   422,   423,   423,   424,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   425,   426,   426,   427,
     427,   427,   427,   428,   429,   429,   429,   430,   430,   432,
     431,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     434,   435,   435,   436,   437,   438,   439,   440,   440,   441,
     441,   441,   442,   442,   442,   443,   444,   445,   446,   446,
     446,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   448,   448,   448,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   450,   451,   451,   451,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   453,   452,   452,   454,   454,   454,
     455,   456,   456,   456,   456,   456,   456,   456,   456,   456,
     456
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     7,     9,     5,
       7,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     5,     5,     5,
       5,     5,     5,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     2,     1,     1,     1,     1,
       1,     5,     5,     7,     7,     5,     8,     8,     2,     2,
       2,     2,     3,     3,     8,     8,     2,     2,     2,     3,
       3,     1,     1,     7,     1,     1,     3,     1,     1,     1,
       1,     1,     4,     7,     2,     2,     1,     4,     7,     2,
       1,     1,     0,     5,     2,     2,     0,     8,     5,     1,
       4,     7,     2,     1,     4,     7,     2,     1,     7,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     2,     3,     3,     3,
       2,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     3,
       3,     2,     3,     3,     1,     3,     1,     3,     3,     3,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       1,     3,     2,     1,     2,     2,     1,     1,     1,     2,
       2,     1,     2,     3,     5,     1,     4,     5,     3,     4,
       3,     2,     4,     5,     3,     4,     4,     2,     1,     5,
       4,     2,     5,     3,     1,     4,     4,     3,     1,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     2,     5,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     1,     1,     1,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     4,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     4,     2,     3,     1,     1,     1,     3,
       4,     4,     4,     6,     6,     6,     6,     6,     4,     2,
       4,     4,     4,     4,     6,     6,     6,     6,     6,     4,
       2,     4,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     4,     2,     4,     4,     6,     2,     4,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     6,     6,
       6,     4,     2,     6,     2,     4,     4,     4,     2,     4,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     3,     2,     4,     3,     2,     4,     3,
       4,     2,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     3,     1,
       3,     1,     3,     1,     4,     3,     1,     4,     4,     4,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     3,
       1,     3,     1,     3,     1,     3,     1,     6,     6,     2,
       4,     4,     2,     4,     0,     5,     2,     0,     3,     1,
       1,     3,     2,     1,     3,     2,     1,     1,     3,     2,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 630 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 631 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 632 "core/cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 5124 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 640 "core/cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 5130 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 641 "core/cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 5136 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 643 "core/cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 5142 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 644 "core/cfg.y" /* yacc.c:1646  */
    {rt=ONSEND_ROUTE;}
#line 5148 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 645 "core/cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 5154 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 650 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
#line 5175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 666 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
		}
	}
#line 5188 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 674 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
			}
		}
	}
#line 5203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 688 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 689 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 695 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 696 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 700 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 701 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 702 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 703 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 704 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 707 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 708 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 709 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 710 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 711 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 712 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 713 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 5307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 717 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 720 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 721 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 722 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 723 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 724 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 728 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 729 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 730 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 731 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 732 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 736 "core/cfg.y" /* yacc.c:1646  */
    {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 737 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5385 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 741 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 745 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("flag list expected\n"); }
#line 5397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 751 "core/cfg.y" /* yacc.c:1646  */
    { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5405 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 754 "core/cfg.y" /* yacc.c:1646  */
    {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5414 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 760 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5420 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 761 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5426 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 766 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("avpflag list expected\n"); }
#line 5432 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 773 "core/cfg.y" /* yacc.c:1646  */
    {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5441 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 779 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5447 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 780 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 5453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 781 "core/cfg.y" /* yacc.c:1646  */
    { dont_fork= ! (yyvsp[0].intval); }
#line 5459 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 782 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5465 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 783 "core/cfg.y" /* yacc.c:1646  */
    { set_fork_delay((yyvsp[0].intval)); }
#line 5471 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 784 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 785 "core/cfg.y" /* yacc.c:1646  */
    { set_modinit_delay((yyvsp[0].intval)); }
#line 5483 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 786 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 787 "core/cfg.y" /* yacc.c:1646  */
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5497 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 790 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5503 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 791 "core/cfg.y" /* yacc.c:1646  */
    {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5514 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 797 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 5520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 798 "core/cfg.y" /* yacc.c:1646  */
    { log_name=(yyvsp[0].strval); }
#line 5526 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 799 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 800 "core/cfg.y" /* yacc.c:1646  */
    { log_color=(yyvsp[0].intval); }
#line 5538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 801 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5544 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 802 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_fmt=(yyvsp[0].strval); }
#line 5550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 803 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 804 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_mode=(yyvsp[0].intval); }
#line 5562 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 805 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 806 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_type=(yyvsp[0].strval); }
#line 5574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 807 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 808 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_data=(yyvsp[0].strval); }
#line 5586 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 809 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5592 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 810 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5600 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 813 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5606 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 814 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5614 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 817 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 818 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 819 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 820 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5638 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 821 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 822 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 823 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5656 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 824 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 825 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 826 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5674 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 827 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 828 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5686 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 829 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5692 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 830 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 831 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5704 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 832 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 833 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5716 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 834 "core/cfg.y" /* yacc.c:1646  */
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 5723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 836 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 837 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 5735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 838 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 839 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 5747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 840 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 841 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 5759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 842 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 843 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 5771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 844 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 845 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 5783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 846 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 847 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 5795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 848 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 849 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 5807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 850 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 851 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 5819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 852 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 853 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 5831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 854 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 855 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 5843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 856 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 857 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 5855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 858 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 859 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 5867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 860 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 861 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 5879 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 862 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 863 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 5891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 864 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 865 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 5903 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 866 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5909 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 867 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 5915 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 868 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5921 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 869 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 5927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 870 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 871 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 5939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 872 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 873 "core/cfg.y" /* yacc.c:1646  */
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 5951 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 874 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5957 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 875 "core/cfg.y" /* yacc.c:1646  */
    {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 5963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 876 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 877 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[0].intval)); }
#line 5975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 878 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 879 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[0].intval));
	}
#line 5989 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 882 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5995 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 883 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 6003 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 886 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6009 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 887 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 6017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 890 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 891 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 892 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 893 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6043 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 896 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6049 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 897 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 900 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 901 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 904 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 905 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6085 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 908 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6091 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 909 "core/cfg.y" /* yacc.c:1646  */
    { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6097 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 910 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6103 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 911 "core/cfg.y" /* yacc.c:1646  */
    { port_no=(yyvsp[0].intval); }
#line 6109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 912 "core/cfg.y" /* yacc.c:1646  */
    { maxbuffer=(yyvsp[0].intval); }
#line 6115 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 913 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6121 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 914 "core/cfg.y" /* yacc.c:1646  */
    { sql_buffer_size=(yyvsp[0].intval); }
#line 6127 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 915 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6133 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 916 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6139 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 917 "core/cfg.y" /* yacc.c:1646  */
    { children_no=(yyvsp[0].intval); }
#line 6145 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 918 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 919 "core/cfg.y" /* yacc.c:1646  */
    { socket_workers=(yyvsp[0].intval); }
#line 6157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 920 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 921 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers((yyvsp[0].intval)); }
#line 6169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 922 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 923 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 924 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6187 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 925 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 926 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 927 "core/cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 6205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 928 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 929 "core/cfg.y" /* yacc.c:1646  */
    { phone2tel=(yyvsp[0].intval); }
#line 6217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 930 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 931 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 932 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 933 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 934 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 935 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 936 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 937 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 938 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 939 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 940 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 941 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 942 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 943 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.sip_parser_log=(yyvsp[0].intval); }
#line 6301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 944 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 945 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 946 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 947 "core/cfg.y" /* yacc.c:1646  */
    { sip_warning=(yyvsp[0].intval); }
#line 6325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 948 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 949 "core/cfg.y" /* yacc.c:1646  */
    { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 952 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 953 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 960 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6369 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 967 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6375 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 968 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 969 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6387 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 970 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6393 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 971 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6399 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 972 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6405 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 973 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6411 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 974 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 975 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6423 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 976 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6429 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 977 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6435 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 978 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6441 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 979 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6447 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 980 "core/cfg.y" /* yacc.c:1646  */
    { mhomed=(yyvsp[0].intval); }
#line 6453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 981 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6459 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 982 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6471 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 989 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 990 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 997 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6495 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 998 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6507 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1005 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6513 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1006 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1013 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6531 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1014 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6543 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1021 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6549 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1022 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6561 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1029 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6567 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1030 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6579 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1037 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6585 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1038 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6600 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1048 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6606 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1049 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6625 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1063 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1077 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 6650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1078 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1085 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1086 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1093 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6686 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1094 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1101 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6704 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1102 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1111 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv4 address expected"); }
#line 6724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1112 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6738 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1121 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv6 address expected"); }
#line 6744 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1122 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6756 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1129 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6762 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1130 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6774 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1137 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6780 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1138 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1145 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6798 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1146 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6810 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1153 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6816 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1154 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1161 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6834 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1162 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6846 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1169 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6852 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1170 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6864 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1177 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6870 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1178 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1185 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6888 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1186 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6900 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1193 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6906 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1194 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1201 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6924 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1202 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6936 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1209 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected");}
#line 6942 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1210 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1217 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6960 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1218 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1225 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1226 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1233 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6996 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1234 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7008 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1241 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1242 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7026 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1249 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7032 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1250 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7044 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1257 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7050 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1258 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7062 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1265 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7068 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1267 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7080 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1274 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7086 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1275 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7102 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1286 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7108 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1287 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7120 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1294 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7126 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1295 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7138 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1302 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7144 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1303 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7156 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1310 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7162 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1311 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7174 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1318 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7180 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1319 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7192 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1326 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7204 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1333 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7216 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1340 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7228 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1347 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7240 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1354 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7252 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1361 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7258 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1362 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7270 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1369 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7276 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1370 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7288 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1377 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7294 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1378 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7306 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1385 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7312 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1386 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1393 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7330 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1394 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7342 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1401 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1402 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7360 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1409 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1410 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1417 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7384 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1418 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7396 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1425 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean or number expected"); }
#line 7402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1426 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7414 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1433 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7420 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1434 "core/cfg.y" /* yacc.c:1646  */
    { server_signature=(yyvsp[0].intval); }
#line 7426 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1435 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7432 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1436 "core/cfg.y" /* yacc.c:1646  */
    { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7440 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1439 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7446 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1440 "core/cfg.y" /* yacc.c:1646  */
    { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1443 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1444 "core/cfg.y" /* yacc.c:1646  */
    { reply_to_via=(yyvsp[0].intval); }
#line 7466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1445 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7472 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1446 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1458 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7506 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1470 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1483 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 7542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1496 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7560 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1509 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7578 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1522 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 7585 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1524 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7601 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1535 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 7607 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1536 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 7613 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1537 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7619 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1538 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 7630 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1544 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7636 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1545 "core/cfg.y" /* yacc.c:1646  */
    {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 7651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1555 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 7657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1556 "core/cfg.y" /* yacc.c:1646  */
    { disable_core_dump=(yyvsp[0].intval); }
#line 7663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1557 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7669 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1558 "core/cfg.y" /* yacc.c:1646  */
    { open_files_limit=(yyvsp[0].intval); }
#line 7675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1559 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1560 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 7693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1567 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1568 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 7711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1575 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1576 "core/cfg.y" /* yacc.c:1646  */
    { mlock_pages=(yyvsp[0].intval); }
#line 7723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1577 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1578 "core/cfg.y" /* yacc.c:1646  */
    { real_time=(yyvsp[0].intval); }
#line 7735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1579 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1580 "core/cfg.y" /* yacc.c:1646  */
    { rt_prio=(yyvsp[0].intval); }
#line 7747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1581 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1582 "core/cfg.y" /* yacc.c:1646  */
    { rt_policy=(yyvsp[0].intval); }
#line 7759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1583 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1584 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_prio=(yyvsp[0].intval); }
#line 7771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1585 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1586 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_policy=(yyvsp[0].intval); }
#line 7783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1587 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1588 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_prio=(yyvsp[0].intval); }
#line 7795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1589 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1590 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_policy=(yyvsp[0].intval); }
#line 7807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1591 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1592 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1599 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1600 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1607 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1608 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1615 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 7873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1622 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 7879 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1623 "core/cfg.y" /* yacc.c:1646  */
    { tos=(yyvsp[0].intval); }
#line 7885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1624 "core/cfg.y" /* yacc.c:1646  */
    { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 7917 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1651 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7923 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1652 "core/cfg.y" /* yacc.c:1646  */
    { pmtu_discovery=(yyvsp[0].intval); }
#line 7929 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1653 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7935 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1654 "core/cfg.y" /* yacc.c:1646  */
    { ser_kill_timeout=(yyvsp[0].intval); }
#line 7941 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1655 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7947 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1656 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 7953 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1657 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1658 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_size((yyvsp[0].intval)); }
#line 7965 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1659 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7971 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1660 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 7977 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1661 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7983 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1662 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 7989 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1663 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7995 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1664 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 8001 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1665 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8007 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1666 "core/cfg.y" /* yacc.c:1646  */
    { http_reply_parse=(yyvsp[0].intval); }
#line 8013 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1667 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1668 "core/cfg.y" /* yacc.c:1646  */
    { ksr_verbose_startup=(yyvsp[0].intval); }
#line 8025 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1669 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8031 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1670 "core/cfg.y" /* yacc.c:1646  */
    { ksr_route_locks_size=(yyvsp[0].intval); }
#line 8037 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1671 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8043 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1672 "core/cfg.y" /* yacc.c:1646  */
    { server_id=(yyvsp[0].intval); }
#line 8049 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1673 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8055 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1674 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 8069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1683 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1684 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 8089 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1693 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1694 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 8109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1703 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8115 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1704 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 8129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1713 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1714 "core/cfg.y" /* yacc.c:1646  */
    { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 8141 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1715 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1716 "core/cfg.y" /* yacc.c:1646  */
    { set_max_recursive_level((yyvsp[0].intval)); }
#line 8153 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1717 "core/cfg.y" /* yacc.c:1646  */
    { sr_dst_max_branches = (yyvsp[0].intval); }
#line 8159 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1718 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 8165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1719 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1720 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 8177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1721 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1722 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 8189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1723 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8195 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1724 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 8201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1725 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1726 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 8213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1727 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8219 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1728 "core/cfg.y" /* yacc.c:1646  */
    { sr_msg_time=(yyvsp[0].intval); }
#line 8225 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1729 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1730 "core/cfg.y" /* yacc.c:1646  */
    { onsend_route_reply=(yyvsp[0].intval); }
#line 8237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1731 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 8243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1732 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 8249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1733 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1735 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8261 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1736 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8267 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1738 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1740 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 8279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1741 "core/cfg.y" /* yacc.c:1646  */
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 8285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1742 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1743 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 8299 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1746 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8305 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1747 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 8313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1750 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1752 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 8325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1756 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1760 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1761 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 8347 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1769 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1774 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1779 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8377 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1784 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8387 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1789 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("number or string expected");
	}
#line 8395 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1792 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8405 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1797 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1805 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_module((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8426 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1811 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8432 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1812 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8447 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1822 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1823 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1833 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8474 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1834 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8488 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1843 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1852 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 8508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1853 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8519 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1859 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1860 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8536 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1866 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1870 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8548 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1871 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8554 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1874 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 8586 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1903 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 8604 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1918 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 8610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1919 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 8616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1923 "core/cfg.y" /* yacc.c:1646  */
    {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 8632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1934 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8638 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1935 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 8644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1939 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1940 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8656 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1944 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 8668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1951 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 8689 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1967 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 8695 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1968 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  request_route  statement"); }
#line 8701 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1971 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8707 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1974 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 8719 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1981 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 8740 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1997 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 8746 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2001 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8752 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2002 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8758 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2007 "core/cfg.y" /* yacc.c:1646  */
    {rt=CORE_ONREPLY_ROUTE;}
#line 8764 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2007 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 8776 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2014 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8782 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2015 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 8788 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2017 "core/cfg.y" /* yacc.c:1646  */
    {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 8794 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2018 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 8820 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2039 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("invalid onreply_route statement");
	}
#line 8828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2044 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8834 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2047 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 8846 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2054 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 8867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2070 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 8873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2073 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8879 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2076 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 8891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2083 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 8912 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2099 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onsend_route statement"); }
#line 8918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2102 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 8924 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2105 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 8945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2122 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 8951 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2125 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 8957 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2126 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid subst preprocess statement"); }
#line 8963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2127 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 0)<0) YYERROR; }
#line 8969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2128 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdef preprocess statement"); }
#line 8975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2129 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), 1)<0) YYERROR; }
#line 8981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2130 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdefs preprocess statement"); }
#line 8987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2152 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 8993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2153 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 8999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2154 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 9005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2155 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 9011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2158 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 9017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2159 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 9023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2160 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 9029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2161 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 9035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2164 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 9041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2165 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 9047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2171 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_EQ_OP; }
#line 9053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2172 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_DIFF_OP; }
#line 9059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2173 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IEQ_OP; }
#line 9065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2174 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IDIFF_OP; }
#line 9071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2175 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STREQ_OP; }
#line 9077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2176 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STRDIFF_OP; }
#line 9083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2177 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_MATCH_OP; }
#line 9089 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2180 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GT_OP; }
#line 9095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2181 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LT_OP; }
#line 9101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2182 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GTE_OP; }
#line 9107 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2183 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LTE_OP; }
#line 9113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2190 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=URI_O;}
#line 9119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2191 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=FROM_URI_O;}
#line 9125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2192 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=TO_URI_O;}
#line 9131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2199 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDPORT_O; }
#line 9137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2200 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=TOPORT_O; }
#line 9143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2201 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDAF_O; }
#line 9149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2205 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCPORT_O; }
#line 9155 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2206 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTPORT_O; }
#line 9161 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2207 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=AF_O; }
#line 9167 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2208 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=MSGLEN_O; }
#line 9173 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2214 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 9179 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2215 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 9185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2218 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCIP_O; }
#line 9191 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2219 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTIP_O; }
#line 9197 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2227 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 9203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2229 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 9209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2230 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string expected"); }
#line 9215 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2232 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 9221 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2234 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 9227 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2236 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9233 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2238 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 9239 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2240 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 9245 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2241 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9251 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2243 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2244 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2245 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9269 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2246 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 9275 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2248 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9281 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2250 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9287 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2252 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9293 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2254 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9299 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2256 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9305 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2258 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9311 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2259 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 9317 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2260 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 9358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2297 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 9364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2299 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2301 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 9376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2303 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 9382 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2306 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2308 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2310 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 9400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2311 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 9406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2315 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 9412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2316 "core/cfg.y" /* yacc.c:1646  */
    {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 9428 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2327 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 9434 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2328 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 9440 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2332 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9446 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2333 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2348 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9486 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2363 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9492 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2364 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9498 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2369 "core/cfg.y" /* yacc.c:1646  */
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				strcpy((yyval.strval), yy_number_str);
			}
		}
#line 9512 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2381 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9518 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2382 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2397 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9558 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2412 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9565 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2414 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 9572 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2421 "core/cfg.y" /* yacc.c:1646  */
    {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 9609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2463 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2464 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2467 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 9627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2468 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2469 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command"); }
#line 9639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2472 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2473 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2474 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 9657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2475 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 9663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2476 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 9669 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2477 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 9675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2478 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 9681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2479 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 9687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2482 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2490 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 9713 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2500 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 9733 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2517 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9745 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2524 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9757 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2531 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9769 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2538 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2545 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9791 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2550 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 9801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2555 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2556 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2557 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 9819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2558 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 9825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2559 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 9831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2562 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 9845 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2571 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 9855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2578 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2603 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 9906 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2619 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 9912 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2621 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror ("bad switch body"); }
#line 9918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2625 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 9933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2644 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 9947 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2653 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 9964 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2665 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 9982 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2684 "core/cfg.y" /* yacc.c:1646  */
    { sel.n = 0; sel.f[0] = 0; }
#line 9988 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2684 "core/cfg.y" /* yacc.c:1646  */
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 10001 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2694 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM; }
#line 10007 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2695 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO; }
#line 10013 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2696 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 10019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2697 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 10025 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2698 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 10031 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2699 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 10037 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2700 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 10043 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2701 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 10049 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2702 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 10055 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2705 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 10061 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2712 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else s_attr->type = 0;
	}
#line 10071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2719 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.attr) = s_attr; }
#line 10077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2722 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 10087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2729 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 10096 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2751 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 10113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2763 "core/cfg.y" /* yacc.c:1646  */
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 10140 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2787 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 10154 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2798 "core/cfg.y" /* yacc.c:1646  */
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 10180 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2829 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = ASSIGN_T; }
#line 10186 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2833 "core/cfg.y" /* yacc.c:1646  */
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 10201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2843 "core/cfg.y" /* yacc.c:1646  */
    {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 10220 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2857 "core/cfg.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 10235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2869 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[0].intval)); }
#line 10241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2870 "core/cfg.y" /* yacc.c:1646  */
    {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 10248 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2872 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 10254 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2873 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 10260 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2874 "core/cfg.y" /* yacc.c:1646  */
    {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 10279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2888 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 10285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2889 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 10291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2890 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 10297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2891 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10303 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2892 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 10309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2893 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10315 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2894 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2898 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_LNOT_OP; }
#line 10327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2899 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_BNOT_OP; }
#line 10333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2900 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_UMINUS_OP; }
#line 10339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2913 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 10350 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2919 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 10356 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2920 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[0].rv_expr)); }
#line 10362 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2921 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 10368 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2922 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10374 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2923 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10380 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2924 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10386 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2925 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10392 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2926 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10398 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2927 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 10404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2928 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10410 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2929 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10416 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2930 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10422 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2931 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10428 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2932 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10434 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2933 "core/cfg.y" /* yacc.c:1646  */
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 10457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2951 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10463 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2952 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2953 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 10475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2954 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 10481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2955 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 10487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2956 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 10493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2957 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2958 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2959 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2960 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2961 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10523 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2962 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10529 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2963 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2964 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2965 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2966 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10553 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2968 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10559 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2970 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10565 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2971 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10571 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2972 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10577 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2973 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10583 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2974 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10589 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2975 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10595 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2978 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 10604 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2996 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 1; }
#line 10610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2997 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 0; }
#line 10616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2998 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = -1; }
#line 10622 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3001 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10628 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3002 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10634 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3003 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10640 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3004 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3005 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3006 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3007 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3008 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3009 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3010 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3011 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3012 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward argument"); }
#line 10694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3013 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3014 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3015 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3016 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3017 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3018 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3019 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3020 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3021 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3022 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3023 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 10760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3024 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3025 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3026 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3027 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3028 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3029 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10796 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3030 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 10802 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3031 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 10808 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3032 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 10814 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3033 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10820 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3034 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 10826 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3035 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10839 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3043 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10852 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3051 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10865 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3059 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10878 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3067 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3075 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 10904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3083 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10917 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3091 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10930 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3099 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 10943 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3107 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 10949 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3108 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 10956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3110 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3118 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10982 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3126 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 10995 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3134 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11009 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3143 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3152 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 11037 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3161 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11050 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3169 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11064 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3178 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3186 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3187 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 11090 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3189 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 11098 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3192 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11104 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3193 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11110 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3194 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log argument"); }
#line 11116 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3195 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11128 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3202 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11140 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3209 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11146 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3210 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3216 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3223 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3224 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11186 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3230 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11198 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3237 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11204 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3238 "core/cfg.y" /* yacc.c:1646  */
    {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 11215 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3244 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 11223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3247 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 11231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3250 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad parameters"); }
#line 11237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3251 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3252 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 11251 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3255 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3256 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error argument"); }
#line 11263 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3257 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3266 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3275 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3276 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route argument"); }
#line 11303 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3277 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3278 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11315 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3279 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3280 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3281 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11333 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3282 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11339 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3283 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11345 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3284 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11351 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3285 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11357 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3286 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11363 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3287 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11369 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3288 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11375 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3289 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3290 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 11387 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3291 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11393 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3292 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 11402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3296 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 11411 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3300 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3301 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11423 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3302 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 11429 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3303 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11435 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3304 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11441 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3305 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11447 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3306 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11453 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3307 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11459 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3308 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11465 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3309 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11471 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3310 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3311 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11483 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3312 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3313 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11495 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3314 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11501 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3315 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11507 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3316 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11513 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3317 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11519 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3318 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3319 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11531 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3320 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11537 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3321 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11543 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3322 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 11549 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3323 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11555 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3324 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11561 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3325 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11567 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3326 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 11573 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3327 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11586 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3335 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11599 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3343 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 11612 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3351 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11618 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3353 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11624 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3355 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 11630 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3356 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 11646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3367 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3368 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3369 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 11679 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3385 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11685 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3386 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11691 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3387 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 11700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3391 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 11708 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3394 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11714 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3395 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3398 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3401 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11738 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3404 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 11746 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3407 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3410 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11762 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3413 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11770 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3416 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 11778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3419 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 11786 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3422 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 11794 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3425 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11800 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3426 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 11806 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3427 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 11814 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3430 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11820 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3431 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 11826 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3432 "core/cfg.y" /* yacc.c:1646  */
    {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 11839 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3439 "core/cfg.y" /* yacc.c:1646  */
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				free_mod_func_action(mod_func_action);
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 11870 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3465 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("'('')' expected (function call)");}
#line 11876 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3469 "core/cfg.y" /* yacc.c:1646  */
    { }
#line 11882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3470 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 11888 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3473 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 11907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3490 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11916 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3494 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11925 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3498 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 11934 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3502 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11944 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3507 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11953 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3511 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3516 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3520 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 11981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3524 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3528 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 11999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;


#line 12003 "core/cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3534 "core/cfg.y" /* yacc.c:1906  */


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
